//-< AFILE.HPP >------------------------------------------------------*--------*
// GOODS                     Version 1.0          (c) 1992  GARRET    *     ?  *
// ( Garret object oriented data storage )                            *   /\|  *
// File to support asyncronous I/O                                    *  /  \  *
//                           Created:      10-May-95   K.A. Knizhnik  * / [] \ *
//                           Last update:  10-May-95   K.A. Knizhnik  * GARRET *
//--------------------------------------------------------------------*--------*

#ifndef __AFILE_HPP__
 #define __AFILE_HPP__

 #include "dfile.hpp"

 struct awBuffer {
     volatile int    	busy;   // process of writing isn't finished
     volatile int 	bot; 	// end of written part of buffer =
				// = begin of unwritten part 
     volatile int 	top; 	// end of unwritten part of buffer	

     int 		fd; 	// file descriptor	
     int 		semid;  // semaphore identifier

     char       	buf[1]; // buffer
	
     void		StartLoop(); 
     void		Wait();
 };


 class Dbs_A_File : public Dbs_D_File {
   protected:
    static Dbs_A_File* 	Chain;
    Dbs_A_File* 	Next; 
		
    int			Pid; 	// write process identifier
    int			Sid;    // shared memory identifier   
    awBuffer* 		awBuf;	
	
   public:
    int     		Open  ( int Flags, int Mode );
    int			Close (); 	
    int     		Read  ( void* Buffer, unsigned Quant );
    int     		Write ( void* Buffer, unsigned Quant );
    large   		Seek  ( long  Offset, int Whence = 0 );
    int     		ChSize( long  Length );

    Dbs_A_File( const char* File_Name ) : Dbs_D_File(File_Name) { Pid = -1; } 
 };

#endif
