//-< CHANL.CPP >------------------------------------------------------*--------*
// GOODS                     Version 1.0          (c) 1992  GARRET    *     ?  *
// ( Garret object oriented data storage )                            *   /\|  *
// Virtual active channel realisation                                 *  /  \  *
//                           Created:      22-Feb-92   K.A. Knijnik   * / [] \ *
//                           Last update:  23-Mar-94   K.A. Knijnik   * GARRET *
//--------------------------------------------------------------------*--------*

#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <stdio.h>
#include <errno.h>

#include "stdtp.hpp"
#include "ermsg.hpp"
#include "dfile.hpp"
#include "chanl.hpp"

global  Dbs_Channel* Dbs_Channel::Manager;

void Io_Error ( void )  {
  perror ( "I/O low level error " );
  abort ();
}

Dbs_Channel::Dbs_Channel ( nat Limit )  {
  ASSERT ( Limit > 0 );
  Active_File_Table = new Dbs_Active_File [ Limit ];
  memset ( Active_File_Table , 0 , Limit * sizeof ( Dbs_Active_File ) );
  Manager = this;
  Timer = 0;
  Active_Files_Number = 0;
  Active_Files_Limit  = Limit;
}

Dbs_Channel::~Dbs_Channel ( void )  {
  for ( int i = Active_Files_Number; i --; )
     if ( close ( Active_File_Table[i].File->Handle ) != Ok ) Io_Error();
     else Active_File_Table[i].File->Handle = -1;
  delete Active_File_Table;
}

void Dbs_Channel::Revision ( nat Limit )  {
  ASSERT ( Limit > 0 );
  for ( int i = Active_Files_Number; i --; )  {
     ASSERT ( Active_File_Table[i].Stamp >= 0 );
     if ( close ( Active_File_Table[i].File->Handle ) != Ok ) Io_Error ();
     else Active_File_Table[i].File->Handle = -1;
  }
  if ( Limit > Active_Files_Limit )  {
     delete Active_File_Table;
     Active_File_Table = new Dbs_Active_File [ Limit ];
     memset ( Active_File_Table , 0 , Limit * sizeof ( Dbs_Active_File ) );
  }
  Active_Files_Number = 0;
  Active_Files_Limit  = Limit;
}

void  Dbs_Channel::Erase ( Dbs_Active_File* Del )  {
  *Del = Active_File_Table[--Active_Files_Number];
  Del->File->Channel = Del;
}

large   Dbs_Channel::Scale ( void )  {
  for( int i = Active_Files_Number; i--; Active_File_Table[i].Stamp >>= 1 );
  return Timer = LONG_MAX / 2;
}

int Dbs_Channel::Activate_File ( Dbs_D_File* File )  {
  int  Mini = Active_Files_Number;
  if ( Active_Files_Number >= Active_Files_Limit )  {
    large  Min_Stamp = large(LONG_MAX) + 1;
    for ( int i = Mini; i --; )
       if ( large(Active_File_Table[i].Stamp) < Min_Stamp )
          Min_Stamp = Active_File_Table[Mini=i].Stamp;
    ASSERT ( Active_File_Table[Mini].Stamp >= 0 );
    if ( close ( Active_File_Table[Mini].File->Handle ) != Ok ) Io_Error();
    Active_File_Table[Mini].File->Handle = -1;
  } else Active_Files_Number += 1;

  Active_File_Table[Mini].File = File;
  Active_File_Table[Mini].Stamp = Tick ();
  File->Channel = Active_File_Table + Mini;
  File->Handle = open( File->Name, File->Flags, File->Mode);
  if ( File->Handle == -1 )  Erase ( File->Channel );
  else if (lseek(File->Handle,File->Curr_Pos,0) != File->Curr_Pos) Io_Error();
  return File->Handle;
}
