//-< CNVRT.CPP >------------------------------------------------------*--------*
// GOODS                     Version 1.0          (c) 1992  GARRET    *     ?  *
// ( Garret object oriented data storage )                            *   /\|  *
// Convert object representation                                      *  /  \  *
//                           Created:      17-Jan-92   K.A. Knijnik   * / [] \ *
//                           Last update:  17-Jan-92   K.A. Knijnik   * GARRET *
//--------------------------------------------------------------------*--------*

#include "ctalk.hpp"
#include "ctarr.hpp"
#include "ctcls.hpp"
#include "cnvrt.hpp"

#ifdef REVERSE_BYTE_ORDER
    #define REVERSE_SHORT(p) { nat2 v = *p; *p++ = CONVERT_SHORT(v); }
    #define REVERSE_LONG(p)  { nat4 v = *p; *p++ = CONVERT_LONG(v); }
    #define REVERSE_FLOAT(p) { \
       nat4 l = *p, h = *(p+1); *p++ = CONVERT_LONG(h); *p++ = CONVERT_LONG(l);\
    }

    global void Reverse_Byte_Order( Dbs_Object* Hdr, void* Dst, nat4 Size ) {
      Ctk_Class* Class = Ctk_Class::Get( Hdr->Desc );
      union {
        char*   Ptr;
        nat2*   Ptr2;
        nat4*   Ptr4;
      };
      Ptr = (char*)Dst;
      char* End = Ptr + Size;
      REVERSE_SHORT(Ptr2);
      REVERSE_SHORT(Ptr2);
      if (Class->Status & Ctk_Class::Special) {
          switch (Hdr->Desc)  {
            case Dbs_String_Desc:
            case Dbs_Vector_I1_Desc:
              REVERSE_LONG(Ptr4);
              return;
            case Dbs_Vector_I2_Desc:
              REVERSE_LONG(Ptr4);
              while ( Ptr < End ) REVERSE_SHORT(Ptr2);
              return;
            case Dbs_Heap_Desc:
              REVERSE_LONG(Ptr4); // Next
              REVERSE_LONG(Ptr4); // N_Obj
              REVERSE_LONG(Ptr4); // Root
	      return; 
            default:
              Ctk_Base *Bp, **Bpp = (Ctk_Base**) Class->Bases->Items;
              while( TRUE ) {
                  Ctk_Member **Mpp = (Ctk_Member**)Class->Members->Items;
		  for( int n = Class->N_Inst_Vars; -- n >= 0; ) {
		      Ctk_Member* Mp = *Mpp++;
                      Ptr = (char*)Dst + sizeof(Dbs_Header)
			  - sizeof(Dbs_Object) + Mp->Off;
                      if( Mp->Type->Desc == Ctk_Float_Desc ) {
                          REVERSE_FLOAT(Ptr4);
                      } else {
                          REVERSE_LONG(Ptr4);
                      }
                  }
                  if ( (Bp = *Bpp++) == NULL ) break;
                  Class = Bp->Class();
              }
          }
      } else while ( Ptr < End ) REVERSE_LONG(Ptr4);
    }

    global void Convert_Array( Ctk_Array_I4* Arr ) { 
	Dbs_Pointer* Pptr = (Dbs_Pointer*)Arr->Items(); 
        int i = Arr->Size(); 
 
        while( -- i >= 0 ) REVERSE_LONG( Pptr );  
    } 

    global void Convert_Double( nat4* ptr, int n ) { 
        while( --n >= 0 ) REVERSE_FLOAT(ptr);
    }

    global void Convert_Short( nat2* ptr, int n ) { 
        while( --n >= 0 ) REVERSE_SHORT(ptr);
    }

    global void Convert_Int( nat4* ptr, int n ) { 
        while( --n >= 0 ) REVERSE_LONG(ptr);
    }

#endif



