//-< CNVRT.HPP >------------------------------------------------------*--------*
// GOODS                     Version 1.0          (c) 1992  GARRET    *     ?  *
// ( Garret object oriented data storage )                            *   /\|  *
// Convert object representation                                      *  /  \  *
//                           Created:      17-Jan-94   K.A. Knijnik   * / [] \ *
//                           Last update:  17-Jan-94   K.A. Knijnik   * GARRET *
//--------------------------------------------------------------------*--------*

#ifndef  __CNVRT_HPP__
 #define  __CNVRT_HPP__

 #if BYTE_ORDERING != 1234
   #define REVERSE_BYTE_ORDER
 #endif

 #ifdef REVERSE_BYTE_ORDER
   import void Reverse_Byte_Order( Dbs_Object* Hdr, void* Dst, nat4 Size );
   import void Convert_Array( Ctk_Array_I4* );
   import void Convert_Double( nat4*, int n );
   import void Convert_Short( nat2* ptr, int n );
   import void Convert_Int( nat4* ptr, int n );

   #define CONVERT(hdr,dst,sz)  Reverse_Byte_Order(hdr,dst,sz)

   #ifdef m68k
     inline  nat2  CONVERT_SHORT( nat2 v ) {
        asm( "rolw #8,%0" : "=d"(v) : "0"(v) );
        return v;
     }
     inline  nat4  CONVERT_LONG( nat4 v ) {
        asm( "rolw #8,%0; swap %0; rolw #8,%0" : "=d"(v) : "0"(v) );
        return v;
     }
   #else
     #define CONVERT_SHORT(v)     (nat2)(((nat2)(v) >> 8) | ((nat2)(v) << 8))
     #define CONVERT_LONG(v) (CONVERT_SHORT((nat4)(v) >> 16) | (CONVERT_SHORT(v) << 16))
   #endif
   #define CONVERT_DOUBLE(p) Convert_Double((nat4*)p,1)
   #define CONVERT_N_INT(p,n) Convert_Int((nat4*)p,n)
   #define CONVERT_N_SHORT(p,n) Convert_Short((nat2*)p,n)
   #define CONVERT_N_DOUBLE(p,n) Convert_Double((nat4*)p,n)
   #define CONVERT_ARRAY(a) Convert_Array(a)
 #else
   #define CONVERT(hdr,dst,sz)
   #define CONVERT_SHORT(v)     (v)
   #define CONVERT_LONG(v)      (v)

   #define CONVERT_DOUBLE(p) 
   #define CONVERT_N_INT(p,n)
   #define CONVERT_N_SHORT(p,n)
   #define CONVERT_N_DOUBLE(p,n)
   #define CONVERT_ARRAY(a)     
 #endif

#endif
