//-< DFILE.HPP >------------------------------------------------------*--------*
// GOODS                     Version 1.0          (c) 1992  GARRET    *     ?  *
// ( Garret object oriented data storage )                            *   /\|  *
// Low level file I/O operations                                      *  /  \  *
//                           Created:      15-Feb-92   K.A. Knijnik   * / [] \ *
//                           Last update:  26-Mar-92   K.A. Knijnik   * GARRET *
//--------------------------------------------------------------------*--------*

#ifndef __DFILE_HPP__
 #define __DFILE_HPP__

 #include "filio.hpp"

 #ifdef __MSDOS__
   #define F_SETLK    6       // Set file lock
   #define F_SETLKW   7       // Set file lock and wait
   #define F_RDLCK    01      // Lock for read
   #define F_WRLCK    02      // Lock for write
   #define F_UNLCK    03      // Unlock
 #endif

 #include "chanl.hpp"

 import void Io_Error ( void );

 class Dbs_D_File : public Dbs_File {
    friend  class Dbs_Channel;
    friend  class Dbs_M_File ;

   protected :
    Dbs_Active_File * Channel;
    int     Handle;

   public :
    char*   Name;
    int     Mode;
    int     Flags;

    int     Descriptor  ( void ); // return current discriptor
    int     Force ( void ); // fix channel in pool
    void    Free  ( void ); // take off fixing from channel

    int     Open  ( int Flags, int Mode );
    void    Sync  ( void );
    int     Close ( void );
    int     Unlink( void );
    int     Access( int Mode = 0 );
    int     Read  ( void* Buffer, unsigned Quant );
    int     Write ( void* Buffer, unsigned Quant );
    large   Seek  ( long  Offset, int Whence = 0 );
    int     ChSize( long  Length );

    // Locking work only with forced channel
    int     Lock  ( long  Offset, long Length,
                    int Type = F_SETLKW, int Mode = F_WRLCK );
    int     UnLock( long  Offset, long Length );

    int     Rename( const char* New_Name );

    Dbs_D_File( void ) { Handle = -1; }
    Dbs_D_File( const char* File_Name );
    virtual~Dbs_D_File ( void );
 };

#endif
