//-< FILIO.HPP >------------------------------------------------------*--------*
// GOODS                     Version 1.0          (c) 1992  GARRET    *     ?  *
// ( Garret object oriented data storage )                            *   /\|  *
// Low level file I/O operations                                      *  /  \  *
//                           Created:      15-Feb-92   K.A. Knijnik   * / [] \ *
//                           Last update:  26-Mar-92   K.A. Knijnik   * GARRET *
//--------------------------------------------------------------------*--------*

#ifndef __FILIO_HPP__
 #define __FILIO_HPP__

 #define     Ok       0

 #ifdef __MSDOS__
   #include <io.h>
   #define O_SYNC     020      // Synchronous write option
 #else
   #ifdef __bsdi__
      #define O_SYNC  O_FSYNC  // Synchronous write option
   #endif
   #include <sys/types.h>
   #define  O_BINARY  0
 #endif

 #include <fcntl.h>
 #include <sys/stat.h>

 class Dbs_File {
   protected:
     large   Curr_Pos;
     large   Last_Pos;

   public:
     large   Length      ( void ) { return Last_Pos; }
     large   Tell        ( void ) { return Curr_Pos; }

     virtual int   Open  ( int Flags, int Mode = 0666 ) = 0;
     virtual void  Sync  ( void ) = 0;
     virtual int   Close ( void ) = 0;
     virtual int   Unlink( void ) = 0;
     virtual int   Access( int Mode = 0 ) = 0;
     virtual int   Read  ( void* Buffer, unsigned Quant ) = 0;
     virtual int   Write ( void* Buffer, unsigned Quant ) = 0;
     virtual large Seek  ( long  Offset, int Whence = 0 ) = 0;
     virtual int   ChSize( long  Length ) = 0;
};

#endif
