//-< INTRF.HPP >------------------------------------------------------*--------*
// GOODS                     Version 1.0          (c) 1992  GARRET    *     ?  *
// ( Garret object oriented data storage )                            *   /\|  *
// Server - Client interface                                          *  /  \  *
//                           Created:      06-Mar-92   K.A. Knijnik   * / [] \ *
//                           Last update:  22-Oct-92   K.A. Knijnik   * GARRET *
//--------------------------------------------------------------------*--------*

#ifndef  __INTRF_HPP__
 #define  __INTRF_HPP__

 #include "async.hpp"

 //
 // Some constants from ODB environment
 //

 #define RCV_BUF_SIZE       1024
 // maximal length of class identifier =
 //     package name + class name + template parameters names

 //
 // Request from client to server
 //

 struct Dbs_Request {
   enum {
      Start, Length, Finish, Flush, Opened, 
      Call, RPC, RMC, Malloc, Free,
      Read, Reread, Write,
      Trans, Update, Commit,
      Lock, Unlock, Unlock_All,
      Inform, Get_Class, Put_Class,
      Reformat, Relink, 	
      Hold, Release      
   };
   nat1      Cmd ;
   nat1      Type;
   nat2      Size;
   union { 
     nat4      Addr;
     nat4      Long_Size; 
     nat4      Mask;
   };	
 };

 typedef     char	Pid[32]; // identifier of process
 
 import bool DDS_Gap;
 import void DDS_Process( void* );

 // Extract RPC parameter from buffer
 import Ctk_Object Ctk_Get_RPC_Param( char*& Buf, nat2 Desc, 
				      Ctk_Database* Base ); 

 // Put parameter of RPC call in buffer 
 import bool Ctk_Put_RPC_Param( Dnm_Inc_Buffer& Buf, Ctk_Object Obj, 
			        Ctk_Database* Base ); 

 // Calculate method index in class to make possible find this method at server
 import int Ctk_Get_RPC_Index( Ctk_Subr* Proc, Dbs_Object* Obj );

 // Get method by RPC identifier. This function is inverse to Ctk_Get_RPC_Index
 import Ctk_Subr* Ctk_Get_RPC_Subr( Dbs_Object* Obj, int Idx );

#endif

