//-< MFILE.HPP >------------------------------------------------------*--------*
// GOODS                     Version 1.0          (c) 1992  GARRET    *     ?  *
// ( Garret object oriented data storage )                            *   /\|  *
// Low level multi file I/O operations                                *  /  \  *
//                           Created:      15-Feb-92   K.A. Knijnik   * / [] \ *
//                           Last update:  10-Mar-92   K.A. Knijnik   * GARRET *
//--------------------------------------------------------------------*--------*

#ifndef __MFILE_HPP__
 #define __MFILE_HPP__

 #ifdef ASYNC_WRITE
   #include "afile.hpp"
 #else
   #include "dfile.hpp"
 #endif

 struct Dbs_Segment {
   const char*  Name;
   large       Limit;
 };

 class   Dbs_M_File : public Dbs_D_File {
   private:
    Dbs_D_File** Seg;
    large *      Limit;
    nat          Seg_Num;
    nat          Curr_Ind;
    large        Curr_Ofs;

   public :
    Dbs_File*    Segment  ( int i )  { return Seg[i]; }

    int          Open     ( int Flags, int Mode );
    void         Sync     ( void );
    int          Close    ( void );
    int          Unlink   ( void );
    int          Access   ( int Mode = 0 );
    int          Write    ( void* Buffer, unsigned Quant );
    int          Read     ( void* Buffer, unsigned Quant );
    int          ChSize   ( long  Length );
    large        Seek     ( long  Offset, int Whence );

    Dbs_M_File ( nat Number, Dbs_Segment* Segments );
    virtual~Dbs_M_File( void );
 };

#endif
