//-< PSTOR.HPP >------------------------------------------------------*--------*
// GOODS                     Version 1.0          (c) 1992  GARRET    *     ?  *
// ( Garret object oriented data storage )                            *   /\|  *
// Not shared fault protected store interface                         *  /  \  *
//                           Created:      28-Feb-92   K.A. Knijnik   * / [] \ *
//                           Last update:  17-Jan-94   K.A. Knijnik   * GARRET *
//--------------------------------------------------------------------*--------*

#ifndef  __PSTOR_HPP__
 #define  __PSTOR_HPP__

 #include "fstor.hpp"
 #include "dnmem.hpp"

 #define  Odb_Del_Addr   1                     // flag of deleted object
 #define  Odb_Shr_Flag   0x80000000            // flag of shared transaction

 class  Dbs_P_Store  : public Dbs_F_Store {
   protected : // transaction mechanism
    Dnm_Buffer Buf   ;  // buffer for whole transaction
    Dbs_File*  Log   ;  // file with log of changes
    char*      Dst   ;  // current position in trans. buffer
    unsigned   Size  ;  // total size of transaction
    int        Trans ;  // transaction type ( shared, local, ... )
    int        Count ;  // number of objects involved in transaction
    int        T_Numb;  // number of not finished transactions
    int        Holds;   // numbers of storage holds

    void       Gc_Process();
    void       Gc_Mark_Cache();

   public:
    bool       Is_Protected();

    void       Loc_Trans ( int Count, nat4 Size );
    void       Shr_Trans ( int Count, nat4 Size );
    void       Commit    ( void );
    void       Update    ( void );

    void       Write     ( Dbs_Object* Obj );
    void       Free      ( nat4 Address, nat4 Size );

    nat4       Open      ( int Ident, Ctk_Database* Base, nat4 Redo );
    void       Close     ( void );
    void       Flush     ( void );

    void       Hold      ( void );
    void       Release   ( void );

    Dbs_P_Store          ( Dbs_File* Dat_File, Dbs_File* Reg_File,
       Dbs_File* Log_File, int Gc_Period, Dbs_Pool* Pool = Page_Cache )
       : Dbs_F_Store ( Dat_File, Reg_File, Gc_Period, Pool )
         { Log = Log_File, Trans = Not_Trans, T_Numb = 0; }

 };

#endif
