//
//-< TFILE.CPP >-----------------------------------------------------*--------*
// GOODS                    Version 1.0          (c) 1992  GARRET    *     ?  *
// ( Garret object oriented data storage )                           *   /\|  *
// Low level file I/O operations                                     *  /  \  *
//                           Created:     15-Feb-92   K.A. Knijnik   * / [] \ *
//                           Last update: 23-Mar-94   K.A. Knijnik   * GARRET *
//-------------------------------------------------------------------*--------*

#include <stdlib.h>
#include "stdtp.hpp"
#include "numlb.hpp"
#include "tfile.hpp"

int Dbs_T_File::Open( int Flags, int )  {
   if ( Flags & O_CREAT ) {
      Buf = new char [ Buf_Size = Buf_Quant ];
      Last_Pos = Curr_Pos = 0;
      return Ok;
   } else return -1;
}

int Dbs_T_File::Close( void ) {
   delete Buf;
   Buf = NULL;
   return Ok;
}

int Dbs_T_File::Access( int ) { return 0; }

int Dbs_T_File::Unlink( void ) {
   Close();
   return Ok;
}

int Dbs_T_File::Read  ( void* Dst, unsigned Len )  {
   if ( Len > Last_Pos - Curr_Pos ) Len = Last_Pos - Curr_Pos;
   memcpy( Dst, Buf + Curr_Pos, Len );
   Curr_Pos += Len;
   return Len;
}

int Dbs_T_File::Write ( void* Src, unsigned Len )  {
   if ( Curr_Pos + Len > Last_Pos )  {
      if ( Curr_Pos + Len > Buf_Size ) Realloc( Curr_Pos + Len );
      Last_Pos = Curr_Pos + Len;
   }
   memcpy( Buf + Curr_Pos, Src, Len );
   Curr_Pos += Len;
   return Len;
}

large Dbs_T_File::Seek( long Offset, int Whence )  {
   switch( Whence ) {
      case 0: Curr_Pos = Offset; break;
      case 1: Curr_Pos += Offset; break;
      case 2: Curr_Pos = Last_Pos + Offset;
   }
   if ( Curr_Pos > Last_Pos ) {
      if ( Curr_Pos > Buf_Size ) Realloc( Curr_Pos );
      Last_Pos = Curr_Pos;
   }
   return Curr_Pos;
}

void Dbs_T_File::Sync ( void ) {}

int  Dbs_T_File::ChSize( long Size ) {
   Last_Pos = Size;
   if ( Curr_Pos > Last_Pos ) Curr_Pos = Last_Pos;
   if ( Last_Pos > Buf_Size ) Realloc( Last_Pos );
   return Ok;
}
