//-< CTLPK.CPP >------------------------------------------------------*--------*
// C-Talk                   Version 1.0           (c) 1993  GARRET    *     ?  *
//                                                                    *   /\|  *
//                                                                    *  /  \  *
//                                                                    * / [] \ *
///                                                                   * GARRET *
//--------------------------------------------------------------------*--------*
// Edit history:
//                          Last update:

#include "stdtp.hpp"
#include "ermsg.hpp"
#include "numlb.hpp"
#include "ctalk.hpp"
#include "ctarr.hpp"
#include "ctstr.hpp"
#include "ctnum.hpp"
#include "ctlst.hpp"
#include "ctlsp.hpp"

local Ctk_Vector_I1* Buffer;
local char *Ptr, *End;

/* Format of packed node
   -1..-27        // terminated node (NIL)
   -28..-128      // fork node with line number offset
   0..100         // keyword  */
enum {
   Nil    = 121,  // no son
   Fork   = 122,  // fork node with line number
   Atom1  = 123,  // atom ( selector < 256 )
   Atom2  = 124,  // atom
   Int    = 125,  // integer constant
   Float  = 126,  // float constant
   String = 127   // string constant
};

local int unpack ( Ctk_Object* Ref ) {
   int  Code = *Ptr++;
   if ( Code >=  0 ) {
      switch ( Code )  {
         case Nil:
            return 0;
         case Fork:
            Ctk_Cur_Line = *((nat2*)Ptr)++;
            break;
         case Atom1:
            *Ref = new Ctk_Atom ( *((nat1*)Ptr)++ );
            return 0;
         case Atom2:
            *Ref = new Ctk_Atom ( *((nat2*)Ptr)++ );
            return 0;
         case Int:
            *Ref = new Ctk_Integer ( *((int4*)Ptr)++ );
            return 0;
         case Float:
            *Ref = new Ctk_Float ( *((real8*)Ptr)++ );
            return 0;
         case String:
            Ctk_String* Str = Ctk_String::Newc ( Ptr );
            *Ref = Str, Ptr += Str->Size() + 1;
            return 0;
         default:
            *Ref = &Ctk_Atom_Table [ Code ];
            return 0;
      }
   } else Ctk_Cur_Line += Code + 78;
   int Line = Ctk_Cur_Line;
   do {
      Ctk_Node* Node = new Ctk_Node ( NIL, NIL, Line );
      *Ref = Node;
      int eol = unpack ( &Node->Car );
      if ( eol < 0 ) return eol + 1;
      Ref = &Node->Cdr;
   } while ( *(nat1*)Ptr < nat1(-27) );
   return 1 + *Ptr++;
}

local int pack ( Ctk_Object List ) {
   if ( Ptr + 10 >= End ) {
      int Offs = Ptr - Buffer->Items;
      Buffer = Buffer->Ch_Size ( Buffer->N_Elems*2 );
      Ptr = Buffer->Items + Offs;
      End = Buffer->Items + Buffer->N_Elems;
   }
   switch ( List->Desc ) {
      case Ctk_Node_Desc:
         int  Line = ((Ctk_Node*)List)->Line - Ctk_Cur_Line;
         if ( Line >= -50 && Line <= 50 ) *Ptr++ = Line - 78;
         else *Ptr++ = Fork, *((nat2*)Ptr)++ = Ctk_Cur_Line + Line;
         Ctk_Cur_Line += Line;
         while ( TRUE ) {
            int eol = pack ( CAR(List) );
            if ( (List = CDR(List)) == NIL ) return eol - 1;
            if ( eol < 0 ) *Ptr++ = eol;
         }
      case Ctk_Atom_Desc:
         if ( unsigned((char*)List - (char*)Ctk_Atom_Table)
              >= S_LAST*sizeof(Ctk_Atom) )
            if ( ((Ctk_Atom*)List)->Ident >= 256 )
               *Ptr++ = Atom2, *((nat2*)Ptr)++ = ((Ctk_Atom*)List)->Ident;
            else *Ptr++ = Atom1, *Ptr++ = ((Ctk_Atom*)List)->Ident;
         else *Ptr++ = ((Ctk_Atom*)List)->Ident;
         return 0;
      case Ctk_Integer_Desc:
         *Ptr++ = Int, *((int4*)Ptr)++ = ((Ctk_Integer*)List)->Val;
         return 0;
      case Ctk_Float_Desc:
         *Ptr++ = Float, *((real8*)Ptr)++ = ((Ctk_Float*)List)->Val;
         return 0;
      case Ctk_String_Desc:
         *Ptr++ = String;
         if ( Ptr + ((Ctk_String*)List)->Size() + 2 >= End )  {
             int Offs = Ptr - Buffer->Items;
             Buffer = Buffer->Ch_Size ( Buffer->N_Elems * 2 );
             Ptr = Buffer->Items + Offs;
             End = Buffer->Items + Buffer->N_Elems;
         }
         strcpy ( Ptr, ((Ctk_String*)List)->Items() );
         Ptr += ((Ctk_String*)List)->Size() + 1;
         return 0;
      default: *Ptr++ = Nil; return 0;
   }
}

void f_list_check ();


Ctk_Vector_I1* Pack ( Ctk_Object List ) {
   if ( Buffer == NULL ) Buffer = Ctk_Vector_I1::New ( 4000 );
   Ptr = Buffer->Items, End = Buffer->Items + Buffer->N_Elems;
   Ctk_Cur_Line = 0;
   int eol = pack ( List );
   *Ptr++ = eol;
   return Buffer->Sub_Seg ( 0, Ptr - Buffer->Items );
}

Ctk_Object Unpack ( Ctk_Vector_I1* Vec ) {
   Ctk_Cur_Line = 0;
   Ptr = Vec->Items;
   Ctk_Object Head;
   unpack ( &Head );
   return Head;
}
