//-< CTPAC.CPP >------------------------------------------------------*--------*
// C-Talk                   Version 1.0           (c) 1993  GARRET    *     ?  *
//                                                                    *   /\|  *
//                                                                    *  /  \  *
//  C-Talk package                                                    * / [] \ *
//                                                                    * GARRET *
//--------------------------------------------------------------------*--------*
// Edit history:
//                          Last update:

#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "stdtp.hpp"
#include "numlb.hpp"
#include "l2lst.hpp"
#include "memmv.hpp"
#include "ermsg.hpp"
#include "ctalk.hpp"
#include "ctarr.hpp"



global Ctk_Package* Ctk_Package::New ( nat2 File ) {
    char Src_Name [ 64 ];
    char Exe_Name [ 64 ];
    struct stat Src_Info, Exe_Info;
    strcpy ( Src_Name, Ctk_Get_Symbol_Name( File ) );
    strcpy ( Exe_Name, Src_Name );
    strcat ( Src_Name, ".ctk" );
    strcat ( Exe_Name, ".ctx" );
    int sx = stat ( Exe_Name, &Exe_Info );
    if ( sx < 0 && stat( Src_Name, &Src_Info ) < 0 )
       Ctk_Error ( "Sources of package %s not available\n", Src_Name );
    if ( sx < 0 || Src_Info.st_mtime > Exe_Info.st_mtime ) {
       Ctk_Pakage* Pk = new Ctk_Package;
       Pk->Sys = Src_Info.st_mode & S_IWRITE;
       Pk->With = Ctk_Vector_O::New(0);
       Pk->Use = Ctk_Vector_O::New(0);
       Pk->Ident = File;

       Pk->recompile...
       return Pk;
    } else {
       int fd = open( Src_Name, S_RDONLY );
       if ( fd < 0 ) Ctk_Error( "Cann't load package: %s", Sys_Error() );
       char File_Buf[ Exe_Info.st_size ];
       read ( fd, File_Buf, sizeof File_Buf );
       close ( fd );
       char* p = File_Buf;
       int4 Pk_Objs = *((int4*)p)++;
       int4 Ex_Objs = *((int4*)p)++;
       Ctk_Object Pk [ Pk_Objs + Ex_Objs ];
       int4 i;
       for ( i = 0; i < Pk_Objs; i ++ ) {
           nat4  Size, Desc = ((Ctk_Header*)p)->Desc;
           const int Scale[] = { 1, 1, 2, 2, 4, 4, 8, 4 };
           if ( Desc - Ctk_Vector_I1 <= Ctk_Vector_O - Ctk_Vector_I1 )
              Size = *(int4)(p+4) * Scale[ Desc - Ctk_Vector_I1 ];
           else if ( Desc == Ctk_String_Desc )
              Size = *(int4)(p+4);
           else
              Size = CTK_DESC(Desc)->Obj_Size;
           Ctk_Object Obj = Ctk_Object( Ctk_Heap_Block::alloc( Size ) );
           memcpy ( Obj, p, Size );
           Obj->Info |= Ctk_Header::No_Ptr;
           Pk[i] = Obj;
           p += Size;
       }
       while ( -- Ex_Objs >= 0 ) {
           nat2 Slc = Ctk_Find_Atom ( p );
           if ( Slc == 0 && !(Pk[i++] = Ctk_Class::Find_Mbr( Slc )->Proc) )
              Ctk_Error ( "Undefined extern reference %s", p );
           while ( *p++ != '\0' );
       }
       for ( i = Pk_Objs; -- i >= 0; ) {
           Ctk_Object Obj = Pk[i];
           Ctk_Descriptor* Class = Ctk_Descriptor::Get( Obj->Desc );
           if ( !( Class->Hdr_Templ.Info & Ctk_Header::No_Ptr ) ) {
              if ( Class->Desc == Ctk_Class_Desc ) Class->Intern();
              Obj->Info ^= Ctk_Header::No_Ptr;
              nat2* Seg = Class->Ptr_Segm->Items;
              int4  n = Class->Ptr_Segm->N_Elems >> 1;
              Ctk_Object* Ptr = Obj;
              while ( -- n >= 0 ) {
                  (char*)Ptr += *Seg++;
                  int4 j = *Seg++;
                  while ( -- j >= 0 ) {
                     int4 k = *(int4*)Ptr;
                     *Ptr++ = Pk[ k ];
                  }
              }
           }
       }
       int4 *Ref = (int4*)p, *End = (int4*)( File_Buf + sizeof Bile_Buf );
       while ( Ref < End ) {
           nat2* Ptr = (nat2*)( File_Buf + *Ref++ );
           *Ptr = ((Ctk_Descriptor*)Pk[ *Ptr ])->Hdr_Templ.Desc;
       }
       return Pk[0];
    }
}

static int Obj_Counter;
static int Src_Size, Exe_Size;
static char* Src_Buf, *Exe_Buf;

// Nested classes are ommited !!!

static void Mark ( Ctk_Object Obj ) {
    if ( Obj->Info > 2 ) return;
    unsigned Desc = Obj->Desc;
    if ( Desc == Ctk_Class_Desc )
       if ( !( Obj->Info & Ctk_Header::Mark ) ) {
          { Ref_Numb += 1; return; }
       else Src_Size += ((Ctk_Class*)Obj)->Body->Size();
    else if ( Desc == Ctk_Proc_Desc )
       Src_Size += ((Ctk_Proc*)Obj)->Body->Size();
    Obj->Info |= (Obj_Counter++ << 4) | Ctk_Header::Mark;
    Ctk_Descriptor* Class = Ctk_Descriptor::Get( Desc );
    Exe_Size += Obj->Alocated();
    nat2* Seg = Class->Ptr_Segm->Items;
    int4  n = Class->Ptr_Segm->N_Elems >> 1;
    Ctk_Object* Ptr = Obj;
    while ( -- n >= 0 ) {
        (char*)Ptr += *Seg++;
        int4 j = *Seg++;
        while ( -- j >= 0 )  Mark ( *Ptr++ );
    }
}

static void Copy ( Ctk_Object Obj ) {
    if ( Obj->Info <= 2 ) return;
    unsigned Desc = Obj->Desc;
    if ( Desc == Ctk_Class_Desc )
       if ( !( Obj->Info & Ctk_Header::Mark ) ) {
          { Ref_Numb += 1; return; }
       else Src_Size += ((Ctk_Class*)Obj)->Body->Size();
    else if ( Desc == Ctk_Proc_Desc )
       Src_Size += ((Ctk_Proc*)Obj)->Body->Size();
    Obj->Info |= (Obj_Counter++ << 4) | Ctk_Header::Mark;
    Ctk_Descriptor* Class = Ctk_Descriptor::Get( Desc );
    Exe_Size += Obj->Alocated();
    nat2* Seg = Class->Ptr_Segm->Items;
    int4  n = Class->Ptr_Segm->N_Elems >> 1;
    Ctk_Object* Ptr = Obj;
    while ( -- n >= 0 ) {
        (char*)Ptr += *Seg++;
        int4 j = *Seg++;
        while ( -- j >= 0 )  Mark ( *Ptr++ );
    }
}


void Ctk_Package::Save () {
    if ( Stat.Modified ) {
       Src_Size = Proc->Body->Size();
       Exe_Size = 8;
       Obj_Counter = 0;
       Ctk_Member** Mbr = (Ctk_Member**)Class->Members->Items;
       for ( int4 n = Members->N_Elems; -- n >= 0; )
           *Mbr++->Proc->Info |= Ctk_Header::Mark;
       Mark ( this );
       Src_Buf = (char*) alloca( Src_Size );
       Exe_Buf = (char*) alloca( Exe_Size );
       Copy ( this );
    }
}

