#include "curses.hpp"

Window* Window::New( int4 x_bas, int4 y_bas, int4 x_len, int4 y_len ) {
   Win = newwin( y_len, x_len, y_bas, x_bas );
   return this;
}

void  Window::Close() { delwin( Win ); }

void  Window::Flush() { wrefresh( Win ); }

void Window::Puts( int4 x, int4 y, Ctk_String* Str )
  { if ( wmove( Win, y, x ) != ERR ) waddstr( Win, Str->Items() ); }

void  Window::Putc( int4 x, int4 y, int4 Sym )
  { if ( wmove( Win, y, x ) != ERR ) waddch( Win, nat1(Sym) ); }

void  Window::Move( int4 x, int4 y ) { wmove( Win, y, x ); }

void  Window::Clear() { werase( Win ); }

local Ctk_Primitive
   c0( "Window::Flush", cnv(&Window::Flush), "curses::Window" ),
   c1( "Window::Clear", cnv(&Window::Clear), "curses::Window" ),
   c2( "Window::Puts",  cnv(&Window::Puts),  "curses::Window" ),
   c3( "Window::Putc",  cnv(&Window::Putc),  "curses::Window" ),
   c4( "Window::New",   cnv(&Window::New),   "curses::Window" ),
   c5( "Window::Move",  cnv(&Window::Move),  "curses::Window" ),
   c6( "Window::Close", cnv(&Window::Close), "curses::Window" );
