//-< CTORA.HPP >-----------------------------------------------------*--------*
// C-Talk                   Version 1.0          (c) 1993  GARRET    *     ?  *
//                                                                   *   /\|  *
//                                                                   *  /  \  *
//                                                                   * / [] \ *
// C-Talk Oracle interface                                           * GARRET *
//-------------------------------------------------------------------*--------*
// Edit history:
//                          Last update:

#ifndef __CTORA_HPP__
#define __CTORA_HPP__

#include "ctsql.hpp"

extern "C" {
#include <ociapr.h>
}

#define VAR_NOT_IN_LIST		1007
#define NO_DATA_FOUND		1403
#define NULL_VALUE_RETURNED    	1405

struct Ctk_Oracle_Session : Ctk_Rdb_Session { 
    Lda_Def* 	lda;
    nat1* 	hda;

    static nat2 desc;
 
    void	Logout(); 
    void	Open_Cursor(  Ctk_Rdb_Cursor* c ); 

    static Ctk_Oracle_Session* 	Create( const char* user ); 
    static void Initialize(); 

    Ctk_Oracle_Session() : Ctk_Rdb_Session( desc ) {} 
}; 

struct Ctk_Oracle_Cursor : public Ctk_Rdb_Cursor { 
    struct Column { 
        int2	indp;
	nat2	rlen;
	nat2	rcode;
        int2    etype;
        int2    itype;
	nat2    name; 
        int     offs;
	union {
	    nat1   any[1];	
	    int4   i;
	    double f; 
	    struct {
		int4 len;
		char buf[ 2000 ];
	    } s;
	} val;
    };

    Column* 	col;
    Cda_Def* 	cda;

    void 	Close();
    void 	Stop();
    void	Parse( Ctk_String* Sql ); 
    void	Start(); 
    void	Exec( Ctk_String* Sql );   
    Ctk_Object	Fetch(); 
    Ctk_Object	Get(); 
 
    void 	Error();

    Ctk_Oracle_Cursor( Ctk_Oracle_Session* s );  
};

#endif
