//-< CTSQL.HPP >-----------------------------------------------------*--------*
// C-Talk                   Version 1.0          (c) 1993  GARRET    *     ?  *
//                                                                   *   /\|  *
//                                                                   *  /  \  *
//                                                                   * / [] \ *
// C-Talk RDBMS interface                                            * GARRET *
//-------------------------------------------------------------------*--------*

#ifndef __CTSQL_HPP__
#define __CTSQL_HPP__

#include "stdtp.hpp"
#include "numlb.hpp"
#include "l2lst.hpp"
#include "memmv.hpp"
#include "ermsg.hpp"
#include "ctalk.hpp"
#include "ctcol.hpp"
#include "ctstr.hpp"
#include "ctsym.hpp"
#include "ctcls.hpp"
#include "ctlib.hpp"


class Ctk_Rdb_Session : public Ctk_Header { 
  friend class Ctk_Rdb_Cursor;
  protected:
    virtual void	Open_Cursor( Ctk_Rdb_Cursor* c ) = 0; 

  public:
    virtual void	Logout() = 0; 
    Ctk_Rdb_Session( nat2 Desc ) : Ctk_Header( Desc, No_Ptr ) {}
};     

class Ctk_Rdb_Abstract_Cursor : public Ctk_Header { 
  public:
    virtual void 	Close() = 0;
    virtual void 	Parse( Ctk_String* Sql ) = 0;
    virtual void 	Start() = 0;
    virtual void 	Stop() = 0;
    virtual void 	Exec( Ctk_String* Sql ) = 0;
    virtual Ctk_Object 	Fetch() = 0;
    virtual Ctk_Object 	Get() = 0;

    void* 		operator new( size_t, void* self ) { return self; }
  protected:
    Ctk_Rdb_Abstract_Cursor() : Ctk_Header( Desc ) {}
};

class Ctk_Rdb_Cursor : public Ctk_Rdb_Abstract_Cursor { 
  protected:
    Ctk_Class*		Class;
    Ctk_Rdb_Session* 	Session;
    int4		State; 
    int4		N_Cols;

    enum { Closed = 0, Opened = 1, Fetched = 2, Parsed = 4 }; 

  public:
    void 		Close();
    void 		Parse( Ctk_String* Sql );
    void 		Start();
    void 		Stop();
    void 		Exec( Ctk_String* Sql );
    Ctk_Object 		Fetch();
    Ctk_Object 		Get();

    Ctk_Rdb_Cursor*     New( Ctk_Rdb_Session* On );
    Ctk_Rdb_Cursor( Ctk_Rdb_Session* on );
    Ctk_Rdb_Cursor() {}
};

struct Ctk_RDBMS { 
    Ctk_RDBMS* 		Next; 
    static Ctk_RDBMS*   List;
    
    typedef Ctk_Rdb_Session* (*login_fnc)( const char* ); 

    login_fnc		Login;

    static Ctk_Rdb_Session* Open( Ctk_String* User );
    Ctk_RDBMS( login_fnc Fnc ) { Next = List, List = this, Login = Fnc; }  
};

#endif




