#include <stdio.h>
#include <string.h>

int Frq[256][ 256 ];
const unsigned char Ord[ 33 ] = "\xff";

// #define TEXT

struct Code {
  int   Bits;
  int   Len;
  void  Print();
} Pack[ 256 ];

void Code::Print() {
  char str[ 32 ];
  int  val = Bits, num = Len;
  char* ptr = str + num;
  *ptr = 0;
  while ( --num >= 0 )  {
      *--ptr = (val & 1) ? '1' : '0';
      val >>= 1;
  }
  #ifdef TEXT
     printf ( "{%d, %s}\n", Len, str );
  #else
     printf ( "{%d,%d},", Len, Bits );
  #endif
}

void Divide( int, int, int* );

main() {
  int ch, prev = 0;
  while ( (ch = getchar()) != EOF ) {
      ch |= 0x20;
      if ( ch >= 0xe0 ) Frq[prev][ch] += 1, prev = ch;
      else prev = 0;
  }
  for ( int i = 0; i <= 32; i ++ ) {
      memset ( Pack, 0, sizeof Pack );
      #ifdef TEXT
         printf ( "  %c\n", Ord[i] );
      #else
         printf ( "{" );
      #endif
      Divide( 0, 31, Frq[Ord[i]] );
      for (ch = 0; ch < 32; ch++) {
          #ifdef TEXT
             printf ( "\t%c - %d times,\t", Ord[ch], Frq[Ord[i]][Ord[ch]] );
          #endif
          Pack[Ord[ch]].Print();
      }
      #ifndef TEXT
         printf ( "},\n" );
      #endif
  }
}

void Divide( int from, int to, int* Frq ) {
  if (from >= to) return;
  int head = 0, tail = 0;
  int first = from, last = to;
  while (first <= last)  {
      if (head < tail || head == tail && first - from < to - last ) {
          head += Frq[Ord[first]];
          Pack[Ord[first]].Len += 1;
          Pack[Ord[first]].Bits <<= 1;
          first += 1;
      } else {
          tail += Frq[Ord[last]];
          Pack[Ord[last]].Len += 1;
          Pack[Ord[last]].Bits = (Pack[Ord[last]].Bits << 1) + 1;
          last -= 1;
      }
  }
  Divide( from, first - 1, Frq );
  Divide( last + 1, to, Frq );
}
