//-----------------------------------------------------------------------------
// C-Talk programming environment.                     (C) 1993 Garret
//  Interface library
//   Interactors
//    C++ interface
// $Source: /usr/users/cvs-root/mtalk/ctalk/lib/edi/ctedi.hpp,v $
// $Id: ctedi.hpp,v 1.1.1.1 1995/10/04 20:35:43 abramow Exp $
//-----------------------------------------------------------------------------

#ifndef __CTEDI_HPP__
#define __CTEDI_HPP__

#include "stdtp.hpp"
#include "ermsg.hpp"
#include "numlb.hpp"
#include "dnmem.hpp"
#include "semph.hpp"
#include "ctalk.hpp"
#include "ctarr.hpp"
#include "ctstr.hpp"
#include "ctlib.hpp"
#include "../win/ctwin.hpp" 

class Ctk_Event_Binding : Ctk_Header { 	
    friend class Ctk_Controller;
    enum { 
        Any = 1,
        Any_Symbol,
        Any_Control,
        Any_Kbd,
        Any_Mouse,
        Button1_Press,  
        Button2_Press,  
        Button3_Press,
        Button1_Release,  
        Button2_Release,  
        Button3_Release,
        Motion,  
    };  

    int4		Pass;
    int4		Keycode;	
    int4 		State;

    Ctk_String*  	Str; 
    Ctk_Closure* 	Clu; 
    Ctk_String*  	Desc; 
    
    Ctk_Event_Binding();
  public:
    void 	       Change( Ctk_String* seq, Ctk_String* desc );
    Ctk_Event_Binding* New(Ctk_String* s, Ctk_Closure* c, Ctk_String* d,int p);
};

class Ctk_Controller : Ctk_Header { 
    Ctk_Array_O* 	Event_Map; 
 
    Ctk_Controller(); 

  public:
    int		Find_Handler( Ctk_Input_Event* e, int pass );
    void	Add_Handlers( Ctk_Array_O* Hnds );
};

#endif


