//-----------------------------------------------------------------------------
// C-Talk programming environment.                     (C) 1993 Garret
//  Interface library
//   Informational models
//    Primitives implementation
// $Source: /usr/users/cvs-root/mtalk/ctalk/lib/edi/ctsto.cpp,v $
// $Id: ctsto.cpp,v 1.1.1.1 1995/10/04 20:35:43 abramow Exp $
//--------------------------------------------------------------------*--------*

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "ctsto.hpp"

#define STORAGE_METHODS( TP ) \
  void  Line_Storage_##TP::Load ( Ctk_String* File ) {                        \
    const int QUANT = 4096;                                                   \
    File_Name = File;							      \
    int fd = open ( File->Items(), O_RDONLY );                                \
    if ( fd >= 0 ) {                                                          \
       nat4 Real_Size = lseek( fd, 0, 2 ) & -sizeof( Ctk_Type_##TP );         \
       nat4 Alloc_Size = ALIGN( Real_Size, QUANT );                           \
       if ( Alloc_Size - Real_Size < QUANT / 2 )                              \
          Alloc_Size += QUANT;                                                \
       Stack = Ctk_Array_##TP::New ( Alloc_Size / sizeof( Ctk_Type_##TP ) );  \
       lseek ( fd, 0, 0 );                                                    \
       if ( read ( fd, (char*)Stack->Vector->Items + Alloc_Size - Real_Size,  \
          Real_Size ) == Real_Size ) {                                        \
           Bot = 0, Top = (Alloc_Size - Real_Size) / sizeof( Ctk_Type_##TP ); \
           close ( fd );                                                      \
           return;                                                            \
       }                                                                      \
       close ( fd );                                                          \
    }                                                                         \
    CTK_RAISE Ctk_IO_Error;                                                   \
  }                                                                           \
  void  Line_Storage_##TP::Save ( Ctk_String* File ) {                        \
    int fd = open( File->Items(), O_WRONLY|O_CREAT|O_TRUNC, 0777 );           \
    if ( fd >= 0 )                                                            \
       if ( write ( fd, Stack->Vector->Items, Bot*sizeof(Ctk_Type_##TP) ) >= 0\
          && write( fd, Stack->Vector->Items+Top, (Stack->Size()-Top)*        \
             sizeof(Ctk_Type_##TP) ) >= 0 ) {                                 \
                close ( fd ); return;                                         \
       } else close( fd );                                                    \
    CTK_RAISE Ctk_IO_Error;                                                   \
  }                                                                           \
  int4 Text_Storage_##TP::Scan ( Ctk_Array_##TP* Str, int4 Offs ) {           \
    Ctk_Type_##TP* Ptr = &Str->Vector->Items[Offs];                           \
    int4 End = Str->Size();                                                   \
    while ( Offs++ <= End )                                                   \
       if ( *Ptr++ == '\n' ) return Offs;                                     \
    return 0;                                                                 \
  }                                                                           \
  Ctk_Array_I4* Line_Storage_##TP::Map () {                                   \
    const int Quant = 128;                                                    \
    if ( Bot > 0 ) {                                                          \
       Stack->Move( Top - Bot, Stack, 0, Bot );                               \
       Top -= Bot, Bot = 0;                                                   \
    }                                                                         \
    Ctk_Type_##TP* Ptr = Stack->Vector->Items + Top;                          \
    Ctk_Type_##TP* End = Stack->Vector->Items + Stack->Size();                \
    if( Ptr < End && *(End-1) != '\n' ) 				      \
	*End++ = '\n', Stack->Vector->N_Elems += 1;	 	  	      \
    int4 NL = 0;                                                              \
    while ( Ptr < End )                                                       \
        if ( *Ptr++ == '\n' ) NL += 1;                                        \
    Ctk_Array_I4* Str = Ctk_Array_I4::New( ALIGN( NL, Quant ) );              \
    Str->Vector->N_Elems = NL;                                                \
    int4* Lp = Str->Vector->Items;                                            \
    End = Stack->Vector->Items + Top;                                         \
    while ( -- NL >= 0 ) {                                                    \
       Ptr = End;                                                             \
       while ( *End++ != '\n' );                                              \
       *Lp++ = End - Ptr;                                                     \
    }                                                                         \
    return Str;                                                               \
}									      \
local Ctk_Primitive							      \
    p1_##TP ( "Line_Storage_"#TP"::Load", cnv(&Line_Storage_##TP::Load),      \
	 "teditor::a_string_model" ),					      \
    p2_##TP ( "Line_Storage_"#TP"::Save", cnv(&Line_Storage_##TP::Save),      \
	 "teditor::a_string_model" ),					      \
    p3_##TP ( "Line_Storage_"#TP"::Map" , cnv(&Line_Storage_##TP::Map ),      \
	 "teditor::a_string_model" ),					      \
    p4_##TP ( "Text_Storage_"#TP"::Scan", cnv(&Text_Storage_##TP::Scan),      \
	 "teditor::a_text_model"   );

STORAGE_METHODS( I1 );
STORAGE_METHODS( I2 );


void  Text_Storage_I1::Come ( int4 Offs )  {
    int4  Base = S_Bot;
    int4  Line = Bot;
    int4* Bp = &Stack->Vector->Items[ Bot ];
    int4* Tp = &Stack->Vector->Items[ Top ];
    while ( Base < Offs ) {
        int4 Len = *Tp++;
        Base += Len;
        *Bp++ = Len;
        Line += 1;
    }
    while ( Base > Offs ) {
        int4 Len = *--Bp;
        Base -= Len;
        *--Tp = Len;
        Line -= 1;
    }
    Top += Line - Bot;
    Bot = Line;
    S_Bot = Base;
}

void  Text_Storage_I1::Goto ( int4 Line ) {
    if ( nat4(Line) <= Stack->Size() - Top + Bot )  {
       int4* Bp = &Stack->Vector->Items[ Bot ];
       int4* Tp = &Stack->Vector->Items[ Top ];
       int4  Size = 0;
       Line -= Bot, Bot += Line, Top += Line;
       while ( Line < 0 ) {
           int4 Len = *--Bp;
           Size -= Len;
           *--Tp = Len;
           Line += 1;
       }
       while ( Line > 0 ) {
           int4 Len = *Tp++;
           Size += Len;
           *Bp++ = Len;
           Line -= 1;
       }
       S_Bot += Size;
    } else CTK_RAISE Ctk_Bounds_Exception ( Line );
}


local Ctk_Primitive
    p1 ( "Text_Storage::Goto"   , cnv(&Text_Storage_I1::Goto), 
	 "teditor::a_text_model"   ),
    p2 ( "Text_Storage::Come"   , cnv(&Text_Storage_I1::Come), 
	 "teditor::a_text_model"   );

