//-----------------------------------------------------------------------------
// C-Talk programming environment.                     (C) 1993 Garret
//  System Library
//   Arrays
//    C++ interface
// $Source: /usr/users/cvs-root/mtalk/ctalk/lib/sys/ctarr.hpp,v $
// $Id: ctarr.hpp,v 1.1.1.1 1995/10/04 20:35:43 abramow Exp $
//-----------------------------------------------------------------------------

#ifndef __CTARR_HPP__
 #define __CTARR_HPP__

 #define  MAX_ARR_SIZE   0x10000000

 typedef  char        Ctk_Type_I1;
 typedef  nat1        Ctk_Type_U1;
 typedef  int2        Ctk_Type_I2;
 typedef  nat2        Ctk_Type_U2;
 typedef  int4        Ctk_Type_I4;
 typedef  nat4        Ctk_Type_U4;
 typedef  double      Ctk_Type_F;
 typedef  Ctk_Object  Ctk_Type_O;

 struct   Ctk_Vector : Ctk_Header {
     nat4 N_Elems;
     Ctk_Vector( nat2 desc, nat2 info ) : Ctk_Header( desc, info ) {}
 };

 #define CTK_VECTOR( TP, ARG )                                          \
     struct   Ctk_Vector_##TP: public Ctk_Vector {                      \
         Ctk_Type_##TP       Items[ 1 ];                                \
         Ctk_Vector_##TP*    Ch_Size ( nat4 New_Sz );                   \
         Ctk_Vector_##TP*    Push    ( ARG Val );                       \
         ARG                 Pop     ();                                \
         ARG                 Top     ();                                \
         void                Del     ( int4 Bas, int4 Len );            \
         int4                Index   ( ARG Val ) const;                 \
         void                Remove  ( ARG Val );                       \
         void                Set     ( int4 Bas, int4 Len, ARG Val );   \
         Ctk_Vector_##TP*    Sub     ( int4 Bas = 0 );                  \
         Ctk_Vector_##TP*    Sub_Seg ( int4 Bas, int4 Len );            \
         static Ctk_Vector_##TP* New ( nat4 Size );                     \
         static Ctk_Vector_##TP* Create ( nat4 Size ) {                 \
            Ctk_Vector_##TP* Vec = New ( Size );                        \
            Vec->N_Elems = 0;                                           \
            return Vec;                                                 \
         }                                                              \
         Ctk_Vector_##TP() : Ctk_Vector( Ctk_Vector_##TP##_Desc, OBJ ){}\
     }

 #define OBJ  No_Ptr
 CTK_VECTOR(I1,int4); CTK_VECTOR(I2,int4); CTK_VECTOR(I4,int4);
 CTK_VECTOR(U1,int4); CTK_VECTOR(U2,int4); CTK_VECTOR(U4,int4);
 CTK_VECTOR(F,double);

 #undef  OBJ
 #define OBJ  0
 CTK_VECTOR(O,Ctk_Object);

 #define  CTK_ARRAY( TP, ARG )                                          \
   struct Ctk_Array_##TP : public Ctk_Header {                          \
      Ctk_Vector_##TP*  Vector;                                         \
      Ctk_Type_##TP&    Elem( int4 Index )                              \
         { return Vector->Items[ Index ]; }                             \
      Ctk_Type_##TP&    operator[] ( int4 Index )                       \
         { return Vector->Items[ Index ]; }                             \
      Ctk_Type_##TP*    Items()    { return Vector->Items; }            \
      nat4&             Size ()    { return Vector->N_Elems; }          \
      void              Ch_Size    ( nat4 New_Size );                   \
      ARG               Get        ( int4 Index );                      \
      void              Put        ( int4 Index, ARG Val );             \
      void              Swap       ( int4 i, int4 j );                  \
      Ctk_Boolean*      operator== ( Ctk_Array_##TP* Other ) const;     \
      Ctk_Boolean*      operator!= ( Ctk_Array_##TP* Other ) const;     \
      Ctk_Array_##TP*   operator+  ( Ctk_Array_##TP* Other );           \
      void              Append     ( Ctk_Array_##TP* Other );           \
      Ctk_Array_##TP*   Sub_Seg    ( int4 From, int4 Len );             \
      Ctk_Array_##TP*   Sub        ( int4 From = 0 );                   \
      void              Ins        ( int4 Bas, int4 Len, ARG Val );     \
      void              Del        ( int4 Bas, int4 Len );              \
      void              Set        ( int4 Bas, int4 Len, ARG Val );     \
      void              Move       ( int4 Bas, Ctk_Array_##TP* Src,     \
                                     int4 From, int4 Len );             \
      Ctk_Array_##TP*   Copy       ( Ctk_Array_##TP* Src );             \
      void              Create     ( int4 Size );                       \
      void              Push       ( ARG Val );                         \
      ARG               Pop        ( void );                            \
      ARG               Top        ( void );                            \
      int4              Index      ( ARG Val ) const;                   \
      Ctk_Array_##TP*   Cons       ( nat4 Size );                       \
      static Ctk_Array_##TP* New   ( nat4 Size );                       \
      CTK_CONSTRUCTOR( Ctk_Array_##TP, 0 );                             \
      Ctk_Array_##TP(nat2 desc, nat2 info) : Ctk_Header(desc, info) {;} \
 }

 CTK_ARRAY( I1, int4 );
 CTK_ARRAY( I2, int4 );
 CTK_ARRAY( I4, int4 );
 CTK_ARRAY( F,  double );
 CTK_ARRAY( O,  Ctk_Object );

#endif











