//-----------------------------------------------------------------------------
// C-Talk programming environment.                     (C) 1993 Garret
//  System Library
//   Collections
//    C++ interface
// $Source: /usr/users/cvs-root/mtalk/ctalk/lib/sys/ctcol.hpp,v $
// $Id: ctcol.hpp,v 1.1.1.1 1995/10/04 20:35:43 abramow Exp $
//-----------------------------------------------------------------------------

#ifndef __CTCOL_HPP
    #define __CTCOL_HPP__

    struct  Ctk_Empty_Exception : Ctk_Exception {
        Ctk_Empty_Exception() : Ctk_Exception( Ctk_Empty_Exception_Desc ) {}
    };

    struct  Ctk_Full_Exception : Ctk_Exception {
        Ctk_Full_Exception() : Ctk_Exception( Ctk_Full_Exception_Desc ) {}
    };

    struct  Ctk_Not_Found : Ctk_Exception {
        Ctk_Not_Found() : Ctk_Exception( Ctk_Not_Found_Desc ) {}
    };

    struct  Ctk_Bounds_Exception : Ctk_Exception {
        int4                Index;

        Ctk_Bounds_Exception(nat4 Bad_Index)
           : Ctk_Exception( Ctk_Bounds_Exception_Desc ){ Index = Bad_Index; }
    };

    struct  Ctk_SLL_Elem : public Ctk_Header {
        Ctk_SLL_Elem*       Next;
      protected:
        Ctk_SLL_Elem() : Ctk_Header(0) {}
    };

    struct  Ctk_SL_List : public Ctk_Header {
        Ctk_SLL_Elem*       List;
      protected:
        Ctk_SL_List() : Ctk_Header(0) {}
    };

    struct  Ctk_DLL_Elem : public Ctk_Header {
        Ctk_DLL_Elem*       Next;
        Ctk_DLL_Elem*       Prev;
      protected:
        Ctk_DLL_Elem() : Ctk_Header(0) {}
    };

    struct  Ctk_DL_List : public Ctk_Header {
        Ctk_DLL_Elem*       List;
      protected:
        Ctk_DL_List() : Ctk_Header(0) {}
    };

    struct  Ctk_Association : public Ctk_Header {
        Ctk_Association*    Nxt;        // Next element in hash-chain
        Ctk_Object          Key;        // Key object
        Ctk_Object          Val;        // Value
        Ctk_Association( nat2 desc, Ctk_Object next, Ctk_Object key,
            Ctk_Object val ) : Ctk_Header( desc )
                { Nxt = (Ctk_Association*)next, Key = key, Val = val; }
    };

    class   Ctk_HS_Map  : public Ctk_Header {
      public :
        int4                S_Msk;      // Size of table - 1
        Ctk_Vector_O*       H_Tbl;      // Hash-table
        Ctk_Association*    Pump;       // Kluge;
        Ctk_Object          get_at(Ctk_Object I);
        void                put_at(Ctk_Object I, Ctk_Object Elem);
        void                Remove(Ctk_Object I);

        void                Init(int Sz);
      protected:
        Ctk_HS_Map() : Ctk_Header(0) {}
    };

    //-------------------------------------------------------------------------
    // L2_Elem --- element of doubly linked structure
    //         abother flavor of lists
    //-------------------------------------------------------------------------

    class Ctk_L2_Elem : public Ctk_Header {
      public:
        Ctk_L2_Elem*    next;
        Ctk_L2_Elem*    prev;

        Ctk_L2_Elem*    link(Ctk_L2_Elem* after);
        void            unlink();
        Ctk_L2_Elem*    prune();
      protected:
        Ctk_L2_Elem() : Ctk_Header(0) {}
    };

#endif
