//
//-< DTIME.HPP >------------------------------------------------------*--------*
// GARNET                    Version 1.0          (c) 1992  GARRET    *     ?  *
// ( Garret network )                                                 *   /\|  *
// Some network functions description                                 *  /  \  *
//                           Created:      25-Apr-92   K.A. Knijnik   * / [] \ *
//                           Last update:  18-Aug-92   K.A. Knijnik   * GARRET *
//--------------------------------------------------------------------*--------*

#ifndef  __DTIME_HPP__
 #define  __DTIME_HPP__

  class Ctk_Date : public Ctk_Header {
    protected:
      int4      julday;
      void      MDY( nat& m, nat& d, nat& y ) const;
      large 	Jday( nat m, nat d, nat y ) const;

      static bool Leap_Year( unsigned year );
      static bool Correct_Date( unsigned m, unsigned d, unsigned y );

      static const int Days_in_Month[ 12 ];

    public:
      int4      Day();
      int4      Year();
      int4      Month();

      Ctk_Date* Current();
      Ctk_Date*	New( int4 y, int4 m, int4 d );

      Ctk_String* Print( Ctk_String* Template );

      static int4 Days_In_Month( int4 month );
      static int4 Days_In_Year( int4 year );

      Ctk_Date( nat4 d = 0 ) : Ctk_Header( Ctk_Date_Desc, 0 ) { julday = d; }
  };


  struct Ctk_Time : Ctk_Header {
      nat4        Sec;
      Ctk_String* Print( Ctk_String* Template );
      Ctk_Time*   Current ();

      Ctk_Time( nat4 s = 0 ) : Ctk_Header( Ctk_Time_Desc, 0 ) { Sec = s; }
  };

  struct Ctk_Date_Time : public Ctk_Date {
      nat4        	Sec;
      Ctk_String* 	Print( Ctk_String* Template );
      Ctk_Date_Time*  	Current ();
      Ctk_Date_Time( nat4 d = 0, nat4 t = 0 ) : Ctk_Date(d) 
        { Desc = Ctk_Date_Time_Desc, Sec = t; }
      Ctk_Date_Time( time_t lt ); // seconds from 1 Jan 1970
  };

#endif

