//-----------------------------------------------------------------------------
// C-Talk programming environment.                     (C) 1993 Garret
//  System Library
//   File system interface
//    C++ interface
// $Source: /usr/users/cvs-root/mtalk/ctalk/lib/sys/ctfsy.hpp,v $
// $Id: ctfsy.hpp,v 1.1.1.1 1995/10/04 20:35:44 abramow Exp $
//-----------------------------------------------------------------------------

#ifndef __CTFSY_HPP__
    #define __CTFSY_HPP__

    class  Ctk_Pathname : public Ctk_Header {
      public:
        static Ctk_Pathname* Newc(char const* s);

	Ctk_Pathname(void);
    };

    class Ctk_File_Info;

    class Ctk_File : public Ctk_Header {
      public:
	enum { dir 		= 0x01,  // directory
           normal	= 0x02,  // ordinary file
	   s_socket	= 0x04,	 // socket
	   s_link	= 0x08,  // symbolic link
	   b_dev	= 0x10,  // block device
	   c_dev	= 0x20,  // character device
	   a_dev	= 0x30,  // any device
	   pipe		= 0x40,  // named pipe
           frob		= 0x80,  // something strange
           all		= 0xff}; // everything


	Ctk_File();

	static void  create(Ctk_String* file_name);
	static void  remove(Ctk_String* file_name);
	static void  rename(Ctk_String* old_file_name, 
			    Ctk_String* new_file_name);
	static void  copy  (Ctk_String* old_file_name,
			    Ctk_String* new_file_name);

	static void  dir_create(Ctk_String* dir_name);
	static void  dir_remove(Ctk_String* dir_name);
	static void  dir_append_m(Ctk_String* path, Ctk_Array_O* a, int mask);
	static void  dir_append(Ctk_String* path, Ctk_Array_O* a);

	static Ctk_File_Info* get_info(Ctk_String* path);
	static void  Initialise();
    };

    class Ctk_Date_Time;

    class Ctk_File_Info : public Ctk_Header {
      public:
	Ctk_File_Info(nat2 id) : Ctk_Header(id,0){;}

	Ctk_String*	name;
	Ctk_Date_Time*	date;
	int4		size;
    };
#endif

