//-----------------------------------------------------------------------------
// C-Talk programming environment.                     (C) 1993 Garret
//  System Library
//   IO streams
//    C++ interface
// $Source: /usr/users/cvs-root/mtalk/ctalk/lib/sys/ctios.hpp,v $
// $Id: ctios.hpp,v 1.1.1.1 1995/10/04 20:35:44 abramow Exp $
//-----------------------------------------------------------------------------

#ifndef __CTIOS_HPP__
    #define __CTIOS_HPP__

    // #define  __IOSTREAM__

    class iostream;

    struct Ctk_IO_Error : Ctk_Exception {
        Ctk_String*  Msg;
        Ctk_IO_Error ();
    };

    struct Ctk_Stream : public Ctk_Resource {
        #ifdef  __IOSTREAM__ // if existed good stream library
           iostream* Stream;
        #else
           FILE*     Stream;
        #endif
	bool 	       OK() { 
	    if( !Stream ) { CTK_RAISE Ctk_Not_Available; return FALSE; }
	    else return TRUE; 
        }

        int4           Flags     (int4 f, int4 mask);
        int4           Fill      (int4 newf);
        int4           Width     (int4 neww);
        int4           Precision (int4 newp);

        Ctk_Boolean*   Fail      (void);
        Ctk_Boolean*   Bad       (void);
        Ctk_Boolean*   Eof       (void);
        Ctk_Boolean*   Empty     (void);

        Ctk_String*    Getlinel  (int4 Lim);
        Ctk_String*    Getline   (void);
        Ctk_String*    Gets      (void);
        int4           Getc      (void);
        int4           Geti      (void);
        double         Getf      (void);
        Ctk_Stream*    Unget     (void);

        int4           Tellg     (void);
        Ctk_Stream*    Seekg     (int4 Pos);
        Ctk_Stream*    Seekgd    (int4 Offs, int4 Dir);
        int4           Tellp     (void);
        Ctk_Stream*    Seekp     (int4 Pos);
        Ctk_Stream*    Seekpd    (int4 Offs, int4 Dir);

        Ctk_Stream*    Flush     (void);
        Ctk_Stream*    Puts      (Ctk_String* Str);
        Ctk_Stream*    Putc      (int4  c);
        Ctk_Stream*    Puti      (int4  i);
        Ctk_Stream*    Putf      (double d);
        Ctk_Stream*    Putback   (int4  c);

        void	       Close     (void);

        static Ctk_Stream* Open  (Ctk_String* File, Ctk_String* Mode);

        Ctk_String*    Readn     ( int4 Len );
        Ctk_String*    Read      ();
        void           Write     ( Ctk_String* Str );

        static Ctk_String* Printf( Ctk_String* Frm, Ctk_Object Val );

        static void Standard_Streams( Ctk_Stream* Std[3] );

        #ifdef  __IOSTREAM__ // if existed good stream library
           Ctk_Stream( iostream* s ) : Ctk_Resource( Ctk_Stream_Desc ) 
             { Stream = s; }
        #else
           Ctk_Stream( FILE* s ) : Ctk_Resource( Ctk_Stream_Desc ) 
             { Stream = s; }
	#endif
	// dummy constructor for generating trampolines
        Ctk_Stream() : Ctk_Resource( Ctk_Stream_Desc, NULL ) {}
    };

#endif
