//-----------------------------------------------------------------------------
// C-Talk programming environment.                     (C) 1993 Garret
//  System Library
//   Lisp lists
//    C++ interface
// $Source: /usr/users/cvs-root/mtalk/ctalk/lib/sys/ctlst.hpp,v $
// $Id: ctlst.hpp,v 1.2 1995/11/26 17:41:33 abramow Exp $
//-----------------------------------------------------------------------------

#ifndef __CTLST_HPP__
    #define __CTLST_HPP__

    //-------------------------------------------------------------------------
    // Ctk_Pair -- lisp like pair object
    //-------------------------------------------------------------------------

    struct  Ctk_Pair :  public  Ctk_Header  {
        Ctk_Object      Car;
        Ctk_Object      Cdr;

        #define CAR( x )        ( ((Ctk_Pair*)(x))->Car )
        #define SETCAR( x, y )  ( ((Ctk_Pair*)(x))->Car = Ctk_Object(y) )
        #define CDR( x )        ( ((Ctk_Pair*)(x))->Cdr )
        #define SETCDR( x, y )  ( ((Ctk_Pair*)(x))->Cdr = Ctk_Object(y) )

        #define CAAR( x )       CAR( CAR( x ))
        #define CADR( x )       CAR( CDR( x ))
        #define CDAR( x )       CDR( CAR( x ))
        #define CDDR( x )       CDR( CDR( x ))
        #define CADDR( x )      CAR( CDR( CDR( x )))
        #define CADDDR( x )     CAR( CDR( CDR( CDR( x ))))

        Ctk_Pair( Ctk_Object head, Ctk_Object tail )
           : Ctk_Header( Ctk_Pair_Desc ) { Car = head, Cdr = tail; }
    };

#endif
