//-< CTMAT.CPP >------------------------------------------------------*--------*
// C-Talk                   Version 1.0           (c) 1993  GARRET    *     ?  *
//                                                                    *   /\|  *
//                                                                    *  /  \  *
//                                                                    * / [] \ *
//                                                                    * GARRET *
//--------------------------------------------------------------------*--------*

#include    "ctalk.hpp"
#include    "ctcol.hpp"
#include    "ctarr.hpp"
#include    "ctstr.hpp"
#include    "ctnum.hpp"
#include    "ctcls.hpp"
#include    "ctmat.hpp"

#define CTK_VECTOR_METHODS( TP, ARG )                                         \
   Vector_##TP* Vector_##TP::New ( int4 Size ) {                              \
       Vector_##TP* u = new Vector_##TP;                                      \
       u->Vector = Ctk_Vector_##TP::New( Size );                              \
       return u;                                                              \
   }                                                                          \
   Vector_##TP* Vector_##TP::operator + ( Vector_##TP* V ) {                  \
       int4 n = Vector->N_Elems;                                              \
       if ( n != V->Vector->N_Elems ) CTK_RAISE Ctk_Dim_Exception;            \
       Vector_##TP* Vec = New( n );                                           \
       Ctk_Type_##TP* Res  = Vec->Vector->Items;                              \
       Ctk_Type_##TP* Opd1 = Vector->Items;                                   \
       Ctk_Type_##TP* Opd2 = V->Vector->Items;                                \
       while ( -- n >= 0 ) *Res++ = *Opd1++ + *Opd2++;                        \
       return Vec;                                                            \
   }                                                                          \
   Vector_##TP* Vector_##TP::operator - ( Vector_##TP* V ) {                  \
       int4 n = Vector->N_Elems;                                              \
       if ( n != V->Vector->N_Elems ) CTK_RAISE Ctk_Dim_Exception;            \
       Vector_##TP* Vec = New( n );                                           \
       Ctk_Type_##TP* Res  = Vec->Vector->Items;                              \
       Ctk_Type_##TP* Opd1 = Vector->Items;                                   \
       Ctk_Type_##TP* Opd2 = V->Vector->Items;                                \
       while ( -- n >= 0 ) *Res++ = *Opd1++ - *Opd2++;                        \
       return Vec;                                                            \
   }                                                                          \
   Vector_##TP* Vector_##TP::Neg ( ) {                                        \
       int4 n = Vector->N_Elems;                                              \
       Vector_##TP* Vec = New( n );                                           \
       Ctk_Type_##TP *Dst = Vec->Vector->Items, *Src = Vector->Items;         \
       while ( -- n >= 0 ) *Dst++ = - *Src++;                                 \
       return Vec;                                                            \
   }                                                                          \
   ARG Vector_##TP::Scalar ( Vector_##TP* V ) {                               \
       int4 n = Vector->N_Elems;                                              \
       if ( n != V->Vector->N_Elems ) CTK_RAISE Ctk_Dim_Exception;            \
       ARG s = 0;                                                             \
       Ctk_Type_##TP *Opd1 = Vector->Items, *Opd2 = V->Vector->Items;         \
       while ( -- n >= 0 ) s += *Opd1++ * *Opd2++;                            \
       return s;                                                              \
   }                                                                          \
   Vector_##TP* Vector_##TP::operator* ( ARG s ) {                            \
       int4 n = Vector->N_Elems;                                              \
       Vector_##TP* Vec = New( n );                                           \
       Ctk_Type_##TP *Dst = Vec->Vector->Items, *Src = Vector->Items;         \
       while ( -- n >= 0 ) *Dst++ = s * *Src++;                               \
       return Vec;                                                            \
   }                                                                          \
   ARG Vector_##TP::Sum ( ) {                                                 \
       Ctk_Type_##TP* Ptr = Vector->Items;                                    \
       ARG s = 0;                                                             \
       for ( int4 n = Vector->N_Elems; -- n >= 0; s += *Ptr++ );              \
       return s;                                                              \
   }                                                                          \
   ARG Vector_##TP::Sum_Abs ( ) {                                             \
       Ctk_Type_##TP* Ptr = Vector->Items;                                    \
       ARG s = 0;                                                             \
       for ( int4 n = Vector->N_Elems; -- n >= 0; )  {                        \
           ARG a = *Ptr++;                                                    \
           s += a >= 0 ? a : -a;                                              \
       }                                                                      \
       return s;                                                              \
   }                                                                          \
   ARG Vector_##TP::Sum_Sqr ( ) {                                             \
       Ctk_Type_##TP* Ptr = Vector->Items;                                    \
       ARG s = 0;                                                             \
       for ( int4 n = Vector->N_Elems; -- n >= 0; )  {                        \
           ARG a = *Ptr++;                                                    \
           s += a*a;                                                          \
       }                                                                      \
       return s;                                                              \
   }                                                                          \
   void Vector_##TP::Sort ( ) {                                               \
       Ctk_Type_##TP* a = Vector->Items;                                      \
       int i, j, k;							      \
									      \
       for ( i = Vector->N_Elems; -- i >= 1; )  {  	                      \
           for ( j = i, k = i; -- j >= 0; )             	              \
               if ( a[j] > a[k] ) k = j;                                      \
           ARG t = a[i];                                                      \
           a[i] = a[k], a[k] = t;                                             \
       }                                                                      \
   }                                                                          \
   int4 Vector_##TP::Mini ( void  ) {                                         \
       Ctk_Type_##TP* p = Vector->Items;                                      \
       int  n = Vector->N_Elems;                                              \
       if ( n <= 0 ) { CTK_RAISE Ctk_Empty_Exception; return -1; }            \
       int min; 							      \
       for ( min = 0; --n > 0; )                                              \
           if ( p[min] > p[n] ) min = n;                                      \
       return min;                                                            \
   }                                                                          \
   int4 Vector_##TP::Maxi ( void ) {                                          \
       Ctk_Type_##TP* p = Vector->Items;                                      \
       int4 n = Vector->N_Elems;                                              \
       if ( n <= 0 ) { CTK_RAISE Ctk_Empty_Exception; return -1; }            \
       int max; 							      \
       for ( max = 0; --n > 0; )                                              \
           if ( p[max] < p[n] ) max = n;                                      \
       return max;                                                            \
   }                                                                          \
   ARG Vector_##TP::Max (void ) {                                             \
       int4 i = Maxi();                                                       \
       return i >= 0 ? Vector->Items[i] : 0;                                  \
   }                                                                          \
   ARG Vector_##TP::Min ( void ) {                                            \
       int4 i = Mini();                                                       \
       return i >= 0 ? Vector->Items[i] : 0;                                  \
   }

#define CTK_VECTOR_PRIMITIVE( TP )                                            \
   V0_##TP( "Vector_"#TP"::New", cnv(&Vector_##TP::New), "vector" ),               \
   V1_##TP( "Vector_"#TP"::Add", cnv(&Vector_##TP::operator+), "vector" ),         \
   V2_##TP( "Vector_"#TP"::Sub", cnv(&Vector_##TP::operator-), "vector" ),         \
   V3_##TP( "Vector_"#TP"::Mul", cnv(&Vector_##TP::operator*), "vector" ),         \
   V4_##TP( "Vector_"#TP"::Scalar", cnv(&Vector_##TP::Scalar), "vector" ),         \
   V5_##TP( "Vector_"#TP"::Neg", cnv(&Vector_##TP::Neg), "vector" ),               \
   V6_##TP( "Vector_"#TP"::Sum", cnv(&Vector_##TP::Sum), "vector" ),               \
   V7_##TP( "Vector_"#TP"::Sum_Sqr", cnv(&Vector_##TP::Sum_Sqr), "vector" ),       \
   V8_##TP( "Vector_"#TP"::Sum_Abs", cnv(&Vector_##TP::Sum_Abs), "vector" ),       \
   V9_##TP( "Vector_"#TP"::Min", cnv(&Vector_##TP::Min), "vector" ),               \
   VA_##TP( "Vector_"#TP"::Max", cnv(&Vector_##TP::Max), "vector" ),               \
   VB_##TP( "Vector_"#TP"::Mini", cnv(&Vector_##TP::Mini), "vector" ),             \
   VC_##TP( "Vector_"#TP"::Maxi", cnv(&Vector_##TP::Maxi), "vector" ),             \
   VD_##TP( "Vector_"#TP"::Sort", cnv(&Vector_##TP::Sort), "vector" )
 


#define CTK_MATRIX_METHODS( TP, ARG )                                         \
   Matrix_##TP* Matrix_##TP::New ( int4 Rows, int4 Cols ) {                   \
      Matrix_##TP* M = new Matrix_##TP;                                       \
      M->Vector = Ctk_Vector_##TP::New( Rows*Cols );                          \
      M->Cols = Cols, M->Rows = Rows;                                         \
      return M;                                                               \
   }                                                                          \
   ARG  Matrix_##TP::Get_Elem( int4 i, int4 j ) {                             \
      if ( nat4(i) >= Rows ) CTK_RAISE Ctk_Bounds_Exception(i);               \
      else if ( nat4(j) >= Cols ) CTK_RAISE Ctk_Bounds_Exception(j);          \
      else return Vector->Items[ i*Cols + j ];                                \
      return (ARG)0;                                                          \
   }                                                                          \
   void  Matrix_##TP::Put_Elem( int4 i, int4 j, ARG Val )  {                  \
      if ( nat4(i) >= Rows ) CTK_RAISE Ctk_Bounds_Exception(i);               \
      else if ( nat4(j) >= Cols ) CTK_RAISE Ctk_Bounds_Exception(j);          \
      else Vector->Items[ i*Cols + j ] = Val;                                 \
   }                                                                          \
   Vector_##TP* Matrix_##TP::Get_Row ( int4 i ) {                             \
      if ( nat4(i) >= Rows ) {CTK_RAISE Ctk_Bounds_Exception(i); return NULL;}\
      Vector_##TP* Row = Vector_##TP::New( Cols );                            \
      memcpy ( Row->Vector->Items, Vector->Items+i*Cols,                      \
          Cols*sizeof(Ctk_Type_##TP) );                                       \
      return Row;                                                             \
   }                                                                          \
   Vector_##TP* Matrix_##TP::Get_Col ( int4 i ) {                             \
      if ( nat4(i) >= Cols ) {CTK_RAISE Ctk_Bounds_Exception(i); return NULL;}\
      Vector_##TP* Vec = Vector_##TP::New( Cols );                            \
      Ctk_Type_##TP *Dst = Vec->Vector->Items, *Src = Vector->Items + i;      \
      for ( int4 r = Rows, c = Cols; -- r >= 0; *Dst++ = *Src, Src += c );    \
      return Vec;                                                             \
   }                                                                          \
   Ctk_Boolean* Matrix_##TP::operator == ( Matrix_##TP* X ) {                 \
      return ( Cols == X->Cols && Rows == X->Rows &&                          \
         memcmp( Vector->Items, X->Vector->Items,  			      \
           Vector->N_Elems*sizeof(Ctk_Type_##TP) ) == 0 )                     \
             ? CTK_TRUE : CTK_FALSE;                                          \
   }                                                                          \
   Ctk_Boolean* Matrix_##TP::operator != ( Matrix_##TP* X ) {                 \
      return ( Cols != X->Cols || Rows != X->Rows ||                          \
         memcmp( Vector->Items, X->Vector->Items,                             \
           Vector->N_Elems*sizeof(Ctk_Type_##TP) ) != 0 )                     \
             ? CTK_TRUE : CTK_FALSE;                                          \
   }                                                                          \
   Matrix_##TP* Matrix_##TP::operator + ( Matrix_##TP* X ) {                  \
      if ( Cols != X->Cols || Rows != X->Rows )                               \
         { CTK_RAISE Ctk_Dim_Exception; return NULL; }                        \
      Matrix_##TP* Y = New(Rows,Cols);                                        \
      Ctk_Type_##TP *Res, *Opd1, *Opd2;                                       \
      Res = Y->Vector->Items, Opd1 = Vector->Items, Opd2 = X->Vector->Items;  \
      for ( int4 n = Vector->N_Elems; -- n >= 0; *Res++ = *Opd1++ + *Opd2++ );\
      return Y;                                                               \
   }                                                                          \
   Matrix_##TP* Matrix_##TP::operator - ( Matrix_##TP* X ) {                  \
      if ( Cols != X->Cols || Rows != X->Rows )                               \
         { CTK_RAISE Ctk_Dim_Exception; return NULL; }                        \
      Matrix_##TP* Y = New(Rows,Cols);                                        \
      Ctk_Type_##TP *Res, *Opd1, *Opd2;                                       \
      Res = Y->Vector->Items, Opd1 = Vector->Items, Opd2 = X->Vector->Items;  \
      for ( int4 n = Vector->N_Elems; -- n >= 0; *Res++ = *Opd1++ - *Opd2++ );\
      return Y;                                                               \
   }                                                                          \
   Matrix_##TP* Matrix_##TP::Mulm ( Matrix_##TP* X ) {                        \
      int i, j, k, n, m;						      \
									      \
      if ( Cols != X->Rows ) { CTK_RAISE Ctk_Dim_Exception; return NULL; }    \
									      \
      Matrix_##TP* Y = New(Rows,X->Cols);                                     \
      register Ctk_Type_##TP *Res, *Col, *Row, *Opd1, *Opd2;                  \
									      \
      Res = Y->Vector->Items, Row = Vector->Items, Col = X->Vector->Items;    \
									      \
      for ( i = Rows, n = X->Cols, m = Cols; -- i >= 0; )  {                  \
          for ( j = n; -- j >= 0; ) {                                         \
              Ctk_Type_##TP Val = 0;                                          \
              Opd1 = Row, Opd2 = Col;                                         \
              for( k = m; -- k >= 0; Val += *Opd1++ * *Opd2, Opd2 += n );     \
              *Res++ = Val;                                                   \
              Col += 1;                                                       \
          }                                                                   \
          Row += m, Col -= n;                                                 \
      }                                                                       \
      return Y;                                                               \
   }                                                                          \
   Vector_##TP* Matrix_##TP::Mulv ( Vector_##TP* V ) {                        \
      if ( Cols != V->Vector->N_Elems )                                       \
         { CTK_RAISE Ctk_Dim_Exception; return NULL; }                        \
      Vector_##TP* U = Vector_##TP::New(Rows);                                \
      register Ctk_Type_##TP *Res, *Col, *Opd1, *Opd2;                        \
      Res = U->Vector->Items, Opd1 = Vector->Items, Col = V->Vector->Items;   \
      for ( int4 n = Rows, m = Cols; -- n >= 0; ) {                           \
          Ctk_Type_##TP Val = 0;                                              \
          Opd2 = Col;                                                         \
          for ( int4 i = m; -- i >= 0; Val += *Opd1++ * *Opd2++ );            \
          *Res++ = Val;                                                       \
      }                                                                       \
      return U;                                                               \
   }                                                                          \
   Matrix_##TP* Matrix_##TP::Muls ( ARG Val ) {                               \
      Matrix_##TP* X = New(Rows,Cols);                                        \
      register Ctk_Type_##TP *Dst, *Src;                                      \
      Src = Vector->Items, Dst = X->Vector->Items;                            \
      for ( int4 n = Vector->N_Elems; -- n >= 0; *Dst++ = *Src++ * Val );     \
      return X;                                                               \
   }                                                                          \
   Matrix_##TP* Matrix_##TP::Transpose() {                                    \
      Matrix_##TP* M = New(Cols,Rows);                                        \
      Ctk_Type_##TP *Dst = M->Vector->Items, *Col = Vector->Items, *Src;      \
      for ( int4 c = Cols, r = Rows, n = c; -- n >= 0; ) {                    \
          Src = Col++;                                                        \
          for ( int4 m = r; -- m >= 0; *Dst++ = *Src, Src += c );             \
      }                                                                       \
      return M;                                                               \
   }                                                                          \
   Matrix_##TP* Matrix_##TP::E( int4 Dim ) {                                  \
      Matrix_##TP* M = New(Dim,Dim);                                          \
      Ctk_Type_##TP *Ptr = M->Vector->Items;                                  \
      Ctk_Type_##TP *End = Ptr + Dim*Dim;                                     \
      Dim += 1;                                                               \
      while ( Ptr < End ) *Ptr = 1, Ptr += Dim;                               \
      return M;                                                               \
   }

inline void Mul ( double* a, double s, int4 n ) {
   while ( -- n >= 0 ) *a++ *= s;
}

inline void Sub_Mul ( double* dst, double* src, double s, int4 n ) {
   while ( -- n >= 0 ) *dst++ -= *src++ * s;
}

inline void Swap_Row ( double* x, double* y, int4 n ) {
   while ( -- n >= 0 ) { double t = *x; *x++ = *y; *y++ = t; }
}

global Matrix_F* Matrix_F::Inverse () {
   if ( Rows != Cols ) { CTK_RAISE Ctk_Dim_Exception; return NULL; }
   int4 i, j, n = Rows;
   Matrix_F* M = E( n );
   double s, *a = New( n, n )->Items(), *b = M->Items(), *ap, *bp;
   memcpy ( a, Items(), sizeof(double)*Size() );
   for ( i = n; i > 0; a += n + 1, b += n, i -- ) {
       for ( ap = a, bp = b, j = i; *ap == 0.0 && -- j > 0; ap += n, bp += n );
       if ( j == 0 )
          { CTK_RAISE Ctk_Math_Exception("Matrix","determinant"); return NULL; }
       if ( i != j ) { Swap_Row ( ap, a, i ); Swap_Row ( bp, b, n ); }
       double s = 1.0 / *a;
       Mul ( a, s, i );
       Mul ( b, s, n );
       for ( ap = a, bp = b, j = i; -- j > 0; ) {
           ap += n, bp += n;
           if ( (s = *ap) != 0.0 )  {
              Sub_Mul( ap, a, s, i );
              Sub_Mul( bp, b, s, n );
           }
       }
   }
   for ( i = n ; -- i > 0; ) {
       a -= n + 1, b -= n;
       for ( ap = a, bp = b, j = i; -- j >= 0; ) {
           ap -= n, bp -= n;
           if ( (s = *ap) != 0.0 ) Sub_Mul( bp, b, s, n );
       }
   }
   return M;
}

global double Matrix_F::Det () {
   if ( Rows != Cols ) { CTK_RAISE Ctk_Dim_Exception; return 0.0; }
   int4 i, j, n = Rows;
   double *a = New( n, n )->Items(), *p;
   double s, t, det = 1.0;
   memcpy ( a, Items(), sizeof(double)*Size() );
   for ( i = n; i > 0; a += n + 1, i -- ) {
       for ( p = a, j = i; *p == 0.0 && -- j > 0; p += n );
       if ( j == 0 ) return 0.0;
       if ( i != j ) { Swap_Row ( p, a, i ); det = -det; }
       det *= t = *a;
       for ( p = a, j = i; -- j > 0; )
           if ( (s = *(p += n)) != 0.0 ) Sub_Mul( p, a, s / t, i );
   }
   return det;
}

#define CTK_MATRIX_PRIMITIVE( TP )                                            \
   M1_##TP( "Matrix_"#TP"::Get_Elem", cnv(&Matrix_##TP::Get_Elem), "matrix" ),     \
   M2_##TP( "Matrix_"#TP"::Put_Elem", cnv(&Matrix_##TP::Put_Elem), "matrix" ),     \
   M3_##TP( "Matrix_"#TP"::Get_Row", cnv(&Matrix_##TP::Get_Row), "matrix" ),       \
   M4_##TP( "Matrix_"#TP"::Get_Col", cnv(&Matrix_##TP::Get_Col), "matrix" ),       \
   M5_##TP( "Matrix_"#TP"::Add", cnv(&Matrix_##TP::operator+),  "matrix" ),        \
   M6_##TP( "Matrix_"#TP"::Sub", cnv(&Matrix_##TP::operator-),  "matrix" ),        \
   M7_##TP( "Matrix_"#TP"::EQ",  cnv(&Matrix_##TP::operator==), "matrix" ),        \
   M8_##TP( "Matrix_"#TP"::NE",  cnv(&Matrix_##TP::operator!=), "matrix" ),        \
   M9_##TP( "Matrix_"#TP"::Mulm", cnv(&Matrix_##TP::Mulm),        "matrix" ),      \
   MA_##TP( "Matrix_"#TP"::Mulv", cnv(&Matrix_##TP::Mulv),        "matrix" ),      \
   MB_##TP( "Matrix_"#TP"::Muls", cnv(&Matrix_##TP::Muls),        "matrix" ),      \
   MC_##TP( "Matrix_"#TP"::Trans", cnv(&Matrix_##TP::Transpose),  "matrix" ),      \
   MD_##TP( "Matrix_"#TP"::New", cnv(&Matrix_##TP::New),  "matrix" ),              \
   ME_##TP( "Matrix_"#TP"::E", cnv(&Matrix_##TP::E),  "matrix" )

CTK_VECTOR_METHODS( I4, int4 );
CTK_VECTOR_METHODS( F, double );

CTK_MATRIX_METHODS( I4, int4 );
CTK_MATRIX_METHODS( F, double );

local Ctk_Primitive
    CTK_MATRIX_PRIMITIVE(I4), CTK_MATRIX_PRIMITIVE(F),
    CTK_VECTOR_PRIMITIVE(I4), CTK_VECTOR_PRIMITIVE(F),
    MF1 ( "Matrix_F::Inverse", cnv(&Matrix_F::Inverse),  "matrix" ),
    MF2 ( "Matrix_F::Det", cnv(&Matrix_F::Det),  "matrix" ); 

