//-< CTMAT.HPP >------------------------------------------------------*--------*
// C-Talk                   Version 1.0           (c) 1993  GARRET    *     ?  *
//                                                                    *   /\|  *
//                                                                    *  /  \  *
//                                                                    * / [] \ *
//                                                                    * GARRET *
//--------------------------------------------------------------------*--------*

#ifndef __CTMAT_HPP__
    #define __CTMAT_HPP__

    struct  Ctk_Dim_Exception : Ctk_Exception {
       Ctk_Dim_Exception() : Ctk_Exception( Ctk_Dim_Exception_Desc ){}
    };

    #define VECTOR( TP, ARG )                          \
        struct Vector_##TP : Ctk_Array_##TP {          \
           Vector_##TP* operator+ ( Vector_##TP* V );  \
           Vector_##TP* operator- ( Vector_##TP* V );  \
           Vector_##TP* operator* ( ARG s );           \
           Vector_##TP* Neg       ( );                 \
           ARG          Scalar    ( Vector_##TP* V );  \
           ARG          Min       ( );                 \
           ARG          Max       ( );                 \
           int4         Mini      ( );                 \
           int4         Maxi      ( );                 \
           ARG          Sum       ( );                 \
           ARG          Sum_Sqr   ( );                 \
           ARG          Sum_Abs   ( );                 \
           void         Sort      ( );                 \
           static Vector_##TP* New( int4 Size );       \
           Vector_##TP() { Desc = Vector_##TP##_Desc; }\
        }

    #define MATRIX( TP, ARG )                                   \
       struct Matrix_##TP : public Vector_##TP {                \
          nat4 Cols, Rows ;                                     \
                                                                \
          ARG           Get_Elem( int4 i, int4 j );             \
          void          Put_Elem( int4 i, int4 j, ARG Val );    \
          Vector_##TP*  Get_Row ( int4 i );                     \
          Vector_##TP*  Get_Col ( int4 j );                     \
          Ctk_Boolean*  operator == ( Matrix_##TP* M );         \
          Ctk_Boolean*  operator != ( Matrix_##TP* M );         \
          Matrix_##TP*  operator +  ( Matrix_##TP* M );         \
          Matrix_##TP*  operator -  ( Matrix_##TP* M );         \
          Matrix_##TP*  Mulm ( Matrix_##TP* M );                \
          Vector_##TP*  Mulv ( Vector_##TP* V );                \
          Matrix_##TP*  Muls ( ARG Val );                       \
          Matrix_##TP*  Pow  ( int4 Exp );                      \
          Matrix_##TP*  Neg  ();                                \
          Matrix_##TP*  Transpose ();                           \
          Matrix_##TP*  Inverse ();                             \
          ARG           Trace ();                               \
          ARG           Det ();                                 \
          int4          Rank ();                                \
          static Matrix_##TP* New ( int4 Rows, int4 Cols );     \
          static Matrix_##TP* E   ( int4 Dim );                 \
          Matrix_##TP() { Desc = Matrix_##TP##_Desc; }          \
    }

    VECTOR( I4, int4 );
    VECTOR( F,  double );

    MATRIX( I4, int4  );
    MATRIX( F,  double );

#endif
