//-----------------------------------------------------------------------------
// C-Talk programming environment.                     (C) 1993 Garret
//  System Library
//   Numbers
//    C++ interface
// $Source: /usr/users/cvs-root/mtalk/ctalk/lib/sys/ctnum.hpp,v $
// $Id: ctnum.hpp,v 1.1.1.1 1995/10/04 20:35:44 abramow Exp $
//-----------------------------------------------------------------------------

#ifndef __CTNUM_HPP__
    #define __CTNUM_HPP__

    struct Ctk_Number : Ctk_Header {
       CTK_CONSTRUCTOR( Ctk_Number, No_Ptr );
    };

    struct  Ctk_Char : Ctk_Header {
       int4         Val;
       Ctk_Char (int4 v) : Ctk_Header( Ctk_Char_Desc, No_Ptr ) { Val = v; }
    };

    struct  Ctk_Short : Ctk_Header {
       int4         Val;
       Ctk_Short (int4 v) : Ctk_Header( Ctk_Short_Desc, No_Ptr ) { Val = v; }
    };

    struct  Ctk_Integer: Ctk_Header {
       int4         Val;
       Ctk_Integer(int4 v) : Ctk_Header( Ctk_Integer_Desc, No_Ptr ) { Val = v; }
    };

    struct  Ctk_Float: Ctk_Header {
       real        Val;
       Ctk_Float(double v) : Ctk_Header( Ctk_Float_Desc, No_Ptr ) { Val = v; }
    };

    struct Ctk_Math_Exception : Ctk_Exception {
       Ctk_String* Type; // type of exception: owerflow, underflow, domain
       Ctk_String* Cop ; // code of operation: sin, cos, ...
       real       Arg1;
       real       Arg2;
       Ctk_Math_Exception( const char* Type, const char* Name,
           double Arg1 = 0.0, double Arg2 = 0.0 );
    };

#endif

