//-----------------------------------------------------------------------------
// C-Talk programming environment.                     (C) 1993 Garret
//  System Library
//   OS Interface
//    Primitives implementation
// $Source: /usr/users/cvs-root/mtalk/ctalk/lib/sys/ctosi.cpp,v $
// $Id: ctosi.cpp,v 1.1.1.1 1995/10/04 20:35:44 abramow Exp $
//-----------------------------------------------------------------------------

#include    <stdlib.h>
#include    <string.h>
#include    <errno.h>

#include    "ctalk.hpp"
#include    "ctarr.hpp"
#include    "ctstr.hpp"
#include    "ctcls.hpp"
#include    "ctfsy.hpp"
#include    "ctosi.hpp"

static nat2 Ctk_System_Error_Descr;

#ifdef  __Besta__
    import  "C" int system(char const* p);
    import  int     sys_nerr;
    import  char*   sys_errlist[];
    #define strerror(i) (i < sys_nerr) ? sys_errlist[i] : "Unknown Error"
#endif

global  const   char*   Ctk_Sys_Err_Text(int i){
    #ifdef __STDC__
        return strerror(i);
    #else
        #error how i can get text for a system error ?
    #endif
}

global	void Ctk_System_Error::Initialise() {
    Ctk_Class* Cls = Ctk_Class::Get_Class_Descr("system", "system_error");
    ASSERT(Cls != NULL);
    Ctk_System_Error_Descr = Cls->Hdr_Templ.Desc;
}

global	Ctk_System_Error::Ctk_System_Error(int i)
  : Ctk_Exception(Ctk_System_Error_Descr)
{
    Code = i;
}

global  Ctk_String*     Ctk_System_Error_As_String(Ctk_System_Error* e){
    return Ctk_String::Newc(Ctk_Sys_Err_Text(e->Code));
}

global  int             Ctk_Sys_Spawn(Ctk_String* Cmd){
    int     i;

    if((i = system((char const*)Cmd->Items())) == -1)
        CTK_RAISE Ctk_System_Error(errno);
    return i;
}


local   int Execute( Ctk_String* Str ) 
{ 
    return system( Str->Items() );
}  

local   Ctk_Primitive
    p0("system_error::As_String", (void*)&Ctk_System_Error_As_String,
        "system_error"),
    p1("sys::Spawn", (void*)&Ctk_Sys_Spawn, "sys"),
    p2("shell::execute", cnv(&Execute), "shell"),
    p3("system_error::Initialise", (void*)&Ctk_System_Error::Initialise,
       "system_error");

