//-----------------------------------------------------------------------------
// C-Talk programming environment.                     (C) 1993 Garret
//  System Library
//   Strings
//    C++ interface
// $Source: /usr/users/cvs-root/mtalk/ctalk/lib/sys/ctstr.hpp,v $
// $Id: ctstr.hpp,v 1.1.1.1 1995/10/04 20:35:44 abramow Exp $
//-----------------------------------------------------------------------------

#ifndef __CTSTR_HPP__
#define __CTSTR_HPP__

#include "ctarr.hpp"

struct Ctk_String;
struct Ctk_Inter_String;
struct Ctk_Video_String;


class Ctk_String: public Ctk_Array_I1 {
  protected:
    Ctk_String (int Len, nat2 v_Desc) {
        Desc = v_Desc;
	Vector = Ctk_Vector_I1::New( Len ); 
    }
  public:
    int4                         Compare     ( Ctk_String* Other );
    Ctk_Boolean*                 operator >  ( Ctk_String* Other );
    Ctk_Boolean*                 operator >= ( Ctk_String* Other );
    Ctk_Boolean*                 operator <  ( Ctk_String* Other );
    Ctk_Boolean*                 operator <= ( Ctk_String* Other );
    Ctk_Boolean*                 operator == ( Ctk_String* Other );
    Ctk_Boolean*                 operator != ( Ctk_String* Other );
    Ctk_String*                  Sub  ( int4 Base = 0 );
    Ctk_String*                  Sub_Str ( int4 Base, int4 Len );
    Ctk_String*                  Trim ( void );
    Ctk_String*                  Tolower( void );
    Ctk_String*                  Toupper( void );
    Ctk_String*                  Capitalize( void );
    Ctk_String*                  Reverse( void );
    Ctk_String*                  Replace( int4 ch, Ctk_String* Str );
    Ctk_String* 		 Replace_Str(Ctk_String* Ocr, Ctk_String* Rep);
    int4                         Loc( Ctk_String* Str, int4 From );
    int4                         Foc( Ctk_String* Str, int4 From );
    void                         Self_Tolower ( void );
    void                         Self_Toupper ( void );
    void                         Self_Capitalize( void );

    Ctk_String (int Len = 0)
       { Desc = Ctk_String_Desc; Vector = Ctk_Vector_I1::New( Len ); }
    Ctk_String( Ctk_Video_String* Str )
       { Desc = Ctk_String_Desc; Cnv_Video( Str ); }
    Ctk_String( Ctk_Inter_String* Str )
       { Desc = Ctk_String_Desc; Cnv_Inter( Str ); }

   static Ctk_String*           Newc( const char* Str );
   static Ctk_String*           New ( nat4 Len ) { return new Ctk_String(Len); }

   Ctk_String*                  Cnv_Video ( Ctk_Video_String* Str );
   Ctk_String*                  Cnv_Inter ( Ctk_Inter_String* Str );

   static int                   Cmp( const char* Str1, int Len1,
                                     const char* Str2, int Len2 );
 };

 struct  Ctk_Inter_String : Ctk_Array_I2 {
   int4                         Compare     ( Ctk_Inter_String* Other );
   Ctk_Boolean*                 operator >  ( Ctk_Inter_String* Other );
   Ctk_Boolean*                 operator >= ( Ctk_Inter_String* Other );
   Ctk_Boolean*                 operator <  ( Ctk_Inter_String* Other );
   Ctk_Boolean*                 operator <= ( Ctk_Inter_String* Other );
   Ctk_Boolean*                 operator == ( Ctk_Inter_String* Other );
   Ctk_Boolean*                 operator != ( Ctk_Inter_String* Other );
   Ctk_Inter_String*            Sub( int4 Base = 0 );
   Ctk_Inter_String*            Sub_Str( int4 Base, int4 Len );
   Ctk_Inter_String*            Trim( void );
   Ctk_Inter_String*            Tolower( void );
   Ctk_Inter_String*            Toupper( void );
   Ctk_Inter_String*            Capitalize( void );
   Ctk_Inter_String*            Reverse( void );
   Ctk_Inter_String*            Replace( int4 ch, Ctk_Inter_String* Str );
   Ctk_Inter_String* 		Replace_Str( Ctk_Inter_String* Ocr, 
					     Ctk_Inter_String* Rep );
   int4                         Loc( Ctk_Inter_String* Str, int4 From );
   int4                         Foc( Ctk_Inter_String* Str, int4 From );
   void                         Self_Tolower( void );
   void                         Self_Toupper( void );
   void                         Self_Capitalize( void );

   Ctk_Inter_String( int Len = 0 )
       { Desc = Ctk_Inter_String_Desc, Vector = Ctk_Vector_I2::New( Len ); }
   Ctk_Inter_String( Ctk_Video_String* Str )
       { Desc = Ctk_Inter_String_Desc, Cnv_Video( Str ); }
   Ctk_Inter_String( Ctk_String* Str )
       { Desc = Ctk_Inter_String_Desc, Cnv_Ascii( Str ); }

   Ctk_Inter_String*     Cnv_Video ( Ctk_Video_String* Str );
   Ctk_Inter_String*     Cnv_Ascii ( Ctk_String* Str );
 };

 struct  Ctk_Video_String : Ctk_Array_I4 {
   Ctk_Video_String*     Cnv_Inter ( Ctk_Inter_String* Str );
   Ctk_Video_String*     Cnv_Ascii ( Ctk_String* Str );

   Ctk_Video_String( Ctk_Inter_String* Str )
       { Desc = Ctk_Video_String_Desc, Cnv_Inter( Str ); }
   Ctk_Video_String( Ctk_String* Str )
       { Desc = Ctk_Video_String_Desc, Cnv_Ascii( Str ); }
   Ctk_Video_String( int Len = 0 )
       { Desc = Ctk_Video_String_Desc, Vector = Ctk_Vector_I4::New( Len ); }
 };

#endif
