//-----------------------------------------------------------------------------
// C-Talk programming environment.                     (C) 1993 Garret
//  System Library
//   Symbols
//    C++ interface
// $Source: /usr/users/cvs-root/mtalk/ctalk/lib/sys/ctype.hpp,v $
// $Id: ctype.hpp,v 1.1.1.1 1995/10/04 20:35:45 abramow Exp $
//-----------------------------------------------------------------------------

#ifndef __CTYPE_HPP
    #define __CTYPE_HPP__

    #define     GSM_MAX_CSET    16
    #define     GSM_MAX_SYMB    (256*GSM_MAX_CSET)

    export  char    const           Gsm_Sym_Attr    [GSM_MAX_SYMB];
    export  short   const           Gsm_Sym_Order   [GSM_MAX_SYMB];
    export  tiny    const           Gsm_To_Upper    [GSM_MAX_SYMB];
    export  tiny    const           Gsm_To_Lower    [GSM_MAX_SYMB];
    export  char    const*  const   Gsm_Cset_Names  [GSM_MAX_CSET];

    #define     _gsU            0x01            // Upper case
    #define     _gsL            0x02            // Lower case
    #define     _gsN            0x04            // Numeral (digit)
    #define     _gsS            0x08            // Spacing character
    #define     _gsP            0x10            // Punctuation
    #define     _gsC            0x20            // Control character
    #define     _gsB            0x40            // Blank
    #define     _gsX            0x80            // heXadecimal digit

    #define     is_lower(x)     (Gsm_Sym_Attr[nat2(x)] & _gsL)
    #define     is_upper(x)     (Gsm_Sym_Attr[nat2(x)] & _gsU)
    #define     is_alpha(x)     (Gsm_Sym_Attr[nat2(x)] & (_gsU | _gsL))
    #define     is_digit(x)     (Gsm_Sym_Attr[nat2(x)] & _gsN)
    #define     is_xdigit(x)    (Gsm_Sym_Attr[nat2(x)] & _gsX)
    #define     is_alnum(x)     (Gsm_Sym_Attr[nat2(x)] & (_gsU | _gsL | _gsN))
    #define     is_space(x)     (Gsm_Sym_Attr[nat2(x)] & _gsS)
    #define     is_punct(x)     (Gsm_Sym_Attr[nat2(x)] & _gsP)
    #define     is_print(x)     (Gsm_Sym_Attr[nat2(x)] & (_gsP|_gsU|_gsL|_gsN|_gsB))
    #define     is_graph(x)     (Gsm_Sym_Attr[nat2(x)] & (_gsP|_gsU|_gsL|_gsN))
    #define     is_cntrl(x)     (Gsm_Sym_Attr[nat2(x)] & _gsC)
    #define     is_ascii(x)     (((x)&0xFF0) == 0)

    #define     to_lower(x)     (Gsm_To_Lower[nat2(x)] | ((x) & ~0xFF))
    #define     to_upper(x)     (Gsm_To_Upper[nat2(x)] | ((x) & ~0xFF))
    #define     to_ascii(x)     ((x) & 0x7F)
    #define     get_cset(x)     ((((unsigned)(x))&0xFF00) >> 8)
    #define     set_cset(x,s)   ((x) = ((x) & ~0xFF00)|(((unsigned)(s)) << 8))
    #define     get_order(x)    (Gsm_Sym_Order[nat2(x)])

    enum    Gaw_Font    {
        Gft_Latin1      =       0x00,
        Gft_Latin2      =       0x01,
        Gft_Latin3      =       0x02,
        Gft_Latin4      =       0x03,
        Gft_Katakana    =       0x04,
        Gft_Arabic      =       0x05,
        Gft_Cyrillic    =       0x06,
        Gft_Greek       =       0x07,
        Gft_Technical   =       0x08,
        Gft_Special     =       0x09,
        Gft_Publishing  =       0x0a,
        Gft_Apl         =       0x0b,
        Gft_Hebrew      =       0x0c,
        Gft_Ibm         =       0x0d
    };

    #define Gft_Extra_Font      Gft_Cyrillic
    #define Gft_Xchar(x)        (((Gft_Extra_Font<<8)|0xFF)&char(x))

    export  void    wstrtoupper(nat2* p, nat4 len);
    export  void    wstrtolower(nat2* p, nat4 len);
    export  void    wstrcap(nat2* p, nat4 len);
    export  void    wstrcset(nat2* p, nat1 Cset, nat4 len);
    export  int     wstrcmp(nat2 const* p, nat4 lenp, nat2 const* q, nat4 lenq);
    export  void    wstrtostr(char* p, nat2 const* q, nat4 len);
    export  void    strtowstr(nat2* p, char const* q, nat1 Cset);
    export  int4    wstrlen(char const* p);
    export  int4    strwlen(nat2 const* p);
#endif
