#include <X11/Xlibint.h>
#include <X11/Xcms.h>
#include <X11/Xutil.h>
#include <X11/Xresource.h>
#include <X11/Xatom.h>
#include <X11/cursorfont.h>
#include <X11/keysym.h>

#include <stdio.h>
#include <string.h>
#include <setjmp.h>

static jmp_buf save;

int IO_Handler( Display* dpy ) { longjmp( save, 1 ); } 


main() { 
    Display* dpy = XOpenDisplay(NULL);
    GC       gc  = DefaultGC( dpy, 0 );
    Window   win = XCreateSimpleWindow( dpy, DefaultRootWindow(dpy), 
	100, 100, 100, 100,  5, WhitePixel(dpy,0), BlackPixel(dpy,0) ); 
    Window   win2 = XCreateSimpleWindow( dpy, DefaultRootWindow(dpy), 
	100, 100, 100, 100,  5, WhitePixel(dpy,0), BlackPixel(dpy,0) ); 

    char*    hello = "Hello X Window System !!!";

    Font font = XLoadFont( dpy, "10x20" ); 
    XSetFont( dpy, gc, font ); 

    struct XFontStruct* xfs = XQueryFont( dpy, font ); 
    int width = XTextWidth( xfs, hello, strlen(hello) );
//     int width = 200; 

    XSetIOErrorHandler(&IO_Handler);
   
    XSetForeground( dpy, gc, WhitePixel( dpy, 0 ) ); 

    struct XSizeHints    xsh;
    xsh.flags = PMinSize;
    xsh.min_width = width + 20;
    xsh.min_height = 50;

    XTextProperty prName, prIconName;
    char* psTitle = "C-Talk X window";
    char* psIconTitle = "CxTalk";
    XStringListToTextProperty( &psTitle, 1, &prName ); 
    XStringListToTextProperty( &psIconTitle, 1, &prIconName ); 

    XSetWMProperties( dpy, win, &prName, &prIconName, NULL, 0, &xsh,
		      NULL, NULL ); 
    XSetWMProperties( dpy, win2, &prName, &prIconName, NULL, 0, &xsh,
		      NULL, NULL ); 

    Atom Exit_Handler = XInternAtom( dpy, "WM_SAVE_YOURSELF", True ); 
    Atom WMProtocols = XInternAtom( dpy, "WM_PROTOCOLS", True ); 
    XSetWMProtocols( dpy, win, &Exit_Handler, 1 ); 
//    XSetWMProtocols( dpy, win2, &Exit_Handler, 1 ); 

    XSelectInput( dpy, win, ExposureMask|StructureNotifyMask|KeyPressMask );
    XSelectInput( dpy, win2, ExposureMask|StructureNotifyMask|KeyPressMask );
    XMapWindow( dpy, win );
    XMapWindow( dpy, win2 );

    if( setjmp( save ) ) { 
	puts( "Return from handler\n" ); 
	exit(1); 
    }

    XEvent e;
    XNextEvent( dpy, &e ); 
    int size_x = 0; 
    while( 1 ) {
	switch( e.type ) {
	    case ConfigureNotify:
		size_x = e.xconfigure.width;
	    case Expose: 
          	XClearWindow( dpy, e.xany.window ); 
            	XDrawString( dpy, e.xany.window, gc, 50, 25, 
			     hello, strlen(hello) );
		break;
	    case ClientMessage:
	        if( e.xclient.message_type == WMProtocols
		   && e.xclient.data.l[0] == Exit_Handler ){
		       puts( "Close session" ); 
		       // goto Exit; 
		}
	        break;
	    case DestroyNotify: 
	        puts( "Destroy window" ); 
	        break;
	  case KeyPress: 
		char str[ 16 ];
		KeySym nKeySym;
		XLookupString( &e.xkey, str, sizeof str, &nKeySym, NULL ); 
		printf( "Keycode = %x, Keysym = %u (%s), State = %x\n", 
			e.xkey.keycode, 
			XLookupKeysym( &e.xkey, e.xkey.state&1 ), str,
			e.xkey.state ); 
	}
        XNextEvent( dpy, &e ); 
    }
  Exit:
    XCloseDisplay( dpy );
}



