//-< CTDEP.HPP >------------------------------------------------------*--------*
// C-Talk                   Version 1.0           (c) 1993  GARRET    *     ?  *
//                                                                    *   /\|  *
//                                                                    *  /  \  *
//                                                                    * / [] \ *
// Machine adjustment                                                 * GARRET *
//--------------------------------------------------------------------*--------*

#ifndef __CTDEP_HPP__
#define __CTDEP_HPP__

// Uncomment this line to use DLD library for packages dynamic loading 
// #define DLL

// Comment this line if you are not going to use asyncronous write operations
#define ASYNC_WRITE


#if defined(__hppa__) || defined(__sparc__) || defined(__alpha__)
  #define STRICT_ALIGN
#endif

#if defined(__alpha__)
  #define BYTES_IN_WORD  8
#else
  #define BYTES_IN_WORD  4
#endif

#if defined(__hppa__) || defined(__sparc__) || defined(__mc68__)
  #define BYTE_ORDERING 4321
#else
  #define BYTE_ORDERING 1234
#endif
 
typedef signed char    int1;
typedef unsigned char  nat1;
typedef signed short   int2;
typedef unsigned short nat2;
typedef signed int     int4;
typedef unsigned int   nat4;

#ifdef STRICT_ALIGN
    struct real {
        struct Double { int4 p0, p1; } D;
        union  map { Double D; double d; };

        double operator+ ( double d ) const { map x; x.D = D; return x.d + d; }
        double operator- ( double d ) const { map x; x.D = D; return x.d - d; }
        double operator/ ( double d ) const { map x; x.D = D; return x.d / d; }
        double operator* ( double d ) const { map x; x.D = D; return x.d * d; }
        double operator- () const { map x; x.D = D; return -x.d; }

	double operator= ( double d) 
          { map x; x.d = d, D = x.D; return d; }
	
        double operator+= ( double d )
          { map x; x.D = D, x.d += d, D = x.D; return x.d; }
        double operator-= ( double d )
          { map x; x.D = D, x.d -= d, D = x.D; return x.d; }
        double operator/= ( double d )
          { map x; x.D = D, x.d /= d, D = x.D; return x.d; }
        double operator*= ( double d )
          { map x; x.D = D, x.d *= d, D = x.D; return x.d; }

        bool operator>= ( double d ) const { map x; x.D = D; return x.d >= d; }
        bool operator>  ( double d ) const { map x; x.D = D; return x.d >  d; }
        bool operator<= ( double d ) const { map x; x.D = D; return x.d <= d; }
        bool operator<  ( double d ) const { map x; x.D = D; return x.d <  d; }
        bool operator== ( double d ) const { map x; x.D = D; return x.d == d; }
        bool operator!= ( double d ) const { map x; x.D = D; return x.d != d; }

        operator double() { map x; x.D = D; return x.d; }
//        operator long()   { map x; x.D = D; return long(x.d); }
        real( double d )  { map x; x.d = d; D = x.D; }
//        real( long l )    { map x; x.d = double(l); D = x.D; }
//        real( int i )     { map x; x.d = double(i); D = x.D; }
        real( real const& r ) { D = r.D; }
        real( void )      {}
    };
#else
    typedef double        real;
#endif

#endif




