// Machine dependent parts of memory management

#include <string.h>
#include <stdlib.h>
#include <unistd.h>

#include "ctalk.hpp"
#include "ctmdp.hpp"

import "C" int end;
import "C" int etext;

#ifndef ASM_CTK_MARK_REGS
    #include <setjmp.h>

    global  void    Ctk_Mark_Regs(void){
        jmp_buf regs;

        memset(&regs, 0, sizeof(jmp_buf));

        (void) setjmp(regs);
        Ctk_Mark((Ctk_Header**)&regs, -(sizeof(jmp_buf)/sizeof(void*)));
    }
#else
    import  "C" void    Ctk_Mark_Regs(void);
#endif

import  char    Ctk_Gc_Last;
import  Ctk_Free_Block* Fix_List_Head[];
import  char*   Ctk_Low_Addr;
import  nat4    Ctk_Data_Size;
import  char*   Ctk_Stack_Top;

#if defined(__osf__)
    extern  _fdata;
#endif

global  void    Ctk_Mark_Roots(void) {
    void** Bot = (void**)alloca(sizeof(void*)) + 1;
    Ctk_Mark_Regs();

    // Scan the stack
    Ctk_Mark( (Ctk_Header**)Bot, Bot - (void**)Ctk_Stack_Top);
#if ADR_ALIGN < 4
    Ctk_Mark( (Ctk_Header**)((char*)Bot+6), (void**)((char*)Bot+6) - (void**)Ctk_Stack_Top );
#endif

    // Scan data area	
    #if defined(__osf__)
      Ctk_Mark((Ctk_Header**)&_fdata, (void**)&_fdata - (void**)Fix_List_Head);
    #elif defined(__linux__) || defined(__svr4__)
      Ctk_Mark((Ctk_Header**)&etext, (void**)&etext - (void**)Fix_List_Head );
      #if ADR_ALIGN < 4
          Ctk_Mark((Ctk_Header**)((char*)&etext+2),
                   (void**)((char*)&etext+2) - (void**)Fix_List_Head);
      #endif
    #else
      Ctk_Mark((Ctk_Header**)&environ,	(void**)&environ - (void**)Fix_List_Head );
      #if ADR_ALIGN < 4 
      	Ctk_Mark((Ctk_Header**)((char*)&environ+2),
		 (void**)((char*)&environ+2) - (void**)Fix_List_Head );
      #endif
    #endif
    Ctk_Mark((Ctk_Header**)&Ctk_Gc_Last, (void**)&Ctk_Gc_Last - (void**)&end );
#if ADR_ALIGN < 4
    Ctk_Mark((Ctk_Header**)(&Ctk_Gc_Last+2), (void**)((char*)&Ctk_Gc_Last+2) - (void**)&end );
#endif
}


