//-----------------------------------------------------------------------------
//   Symbols for Garret C-Talk 
//   Copyright (C) 1993-1995 Garret
//
// This file is part of Garret C-Talk.
//
// Garret C-Talk is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// Garret C-Talk is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Garret C-Talk; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//-----------------------------------------------------------------------------

#ifndef __CTSYM_HPP__
    #define __CTSYM_HPP__

    #include "ctstr.hpp"

    export  Ctk_Vector_O*   Ctk_Syms;
    export  Ctk_Vector_U2*  Ctk_Next;
    export  int             Ctk_Free;

    export  char* const   Ctk_Get_Symbol_Name (nat2 Sel);
    export  nat           Ctk_Add_Sym (Ctk_String* Str);
    export  nat           Ctk_Add_Sym (const char* Str);
    export  nat           Ctk_Find_Sym (const char* Str);
    export  void          Ctk_Sym_Init (void);

    // Ctk_Symbol 
    class   Ctk_Symbol : public Ctk_String {
	nat2		Code;	// Nat2 code of the symbol
      protected:
	Ctk_Symbol(const char* Str);
	friend	nat	Ctk_Add_Sym (const char* Str);
      public:
	nat2		Mask;	// Bit mask

	static Ctk_Symbol* Make_Symbol(const char* Str);
	static Ctk_Symbol* Make_Symbol(Ctk_String* Str);

	// Convert object pointer to symbol identifier
	nat2	Get_Code() {
	    return Code;
	}

	// Get the symbol object by its code
	static Ctk_Symbol* Obj(nat2 s_Code) {
	    return (Ctk_Free > s_Code ? 
		    (Ctk_Symbol*)Ctk_Syms->Items[s_Code] 
		    : (Ctk_Symbol*)NULL);
	}
    };

#endif

