//-----------------------------------------------------------------------------
//   Back end of compiler
//   Copyright (C) 1995 Garret
//
// This file is part of Garret C-Talk.
//
// Garret C-Talk is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// Garret C-Talk is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Garret C-Talk; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//-----------------------------------------------------------------------------

#include "stdtp.hpp"
#include "ctalk.hpp"
#include "mtcmp.hpp"
#include "fifth.hpp"

//-----------------------------------------------------------------------------
// node names
const	char*	irep_node::node_name[irep_node::max_node] = { 
    #define DEF_COMP_NODE(NAME, OPT_ATTR, ALLOWED_TYPES, CATEGORY) #NAME,
    #include "mtcmp.dpp"
};

// operator attributes
const	int	irep_node::node_attr[irep_node::max_node] = {
    #define DEF_COMP_NODE(NAME, OPT_ATTR, ALLOWED_TYPES, CATEGORY) OPT_ATTR
    #include "mtcmp.dpp"
};

// operator allowed type masks 
const	int	irep_node::types_allowed[irep_node::max_node] = {
    #define DEF_COMP_NODE(NAME, OPT_ATTR, ALLOWED_TYPES, CATEGORY) OPT_ATTR
    #include "mtcmp.dpp"
};

// node categories
const	int	irep_node::node_category[irep_node::max_node] = {
    #define DEF_COMP_NODE(NAME, OPT_ATTR, ALLOWED_TYPES, CATEGORY) OPT_ATTR
    #include "mtcmp.dpp"
};

//-----------------------------------------------------------------------------

global	Dnm_Stack	irep_node::A_Stack(DNM_LARGE_QUANT);

global	void	irep_node::cleanup() {
    A_Stack.Restart();
}


