//-< MULTP.HPP >-----------------------------------------------------*--------*
// GOODS                     Version 1.0          (c) 1992  GARRET   *     ?  *
// ( Garret object oriented data storage )                           *   /\|  *
// Input multiplexing                                                *  /  \  *
//                           Created:      23-Jan-94   K.A. Knijnik  * / [] \ *
//                           Last update:  23-Jan-94   K.A. Knijnik  * GARRET *
//-------------------------------------------------------------------*--------*

#ifndef  __MULTP_HPP__
#define  __MULTP_HPP__

#include "semph.hpp"

typedef void (*Supervisor)(void* Arg, int Src);

export void Open_Semaphore(void* Sem, int Src);

export void Multiplex_Channels( bool nowait = FALSE );

export void Attach_Channel(int Desc, Supervisor Func, void* Arg = NULL);
export void Attach_Signal(int Signum, Supervisor Func, void* Arg = NULL);
export void Detach_Channel(int Desc);
export void Detach_Signal(int Signum);

inline void Wait_Input(Semaphore* Sem, int Desc) {
   Attach_Channel(Desc, Open_Semaphore, Sem);
   Sem->wait();
}

#endif
