//-< CTXSW.HPP >-----------------------------------------------------*--------*
// Garret class library.    Version 2.0           (c) 1992  GARRET   *     ?  *
// Simple synchronous processes ( really coroutines )                *   /\|  *
// Interface to low level primitives                                 *  /  \  *
// for lightweighted processess                                      * / [] \ *
// context switching                                                 * GARRET *
//-------------------------------------------------------------------*--------*
// Edit history:
//                          Last update:

#ifndef __CTXSW_HPP__
    #define __CTXSW_HPP__

    // Currently, two methods for context switching are supported :
    //  1 -- All processes run at the system stack, and when context switching
    //       is requered, the portion of stack, specific to running process
    //       is copied to dynamically allocated buffer.
    //  2 -- Process switches its stack to specially allocated buffer in the
    //       heap storage. Only registers are stored/loaded when context
    //       switching is performed.

    extern  "C" {
        /* Support for the first method : */

        export  void*           Tsk_Stack_Base;
        export  int             Tsk_Save_Ret_Value;

        export  int             Tsk_Stack_Size(void);
        export  int             Tsk_Save_Stack(void* Stk);
        export  noret   void    Tsk_Load_Stack(const void* Stk, int R_Code);

        /* Support for the second method : */

        export  int             Tsk_Ctx_Size;   /* Size of task context */

        export  int             Tsk_Save_Context(void* Ctx);
        export  noret   void    Tsk_Load_Context(const void* Ctx, int R_Code);
    };

#endif
