//-< ESTOR.CPP >------------------------------------------------------*--------*
// Garret Simple Text Editor                      (c) 1993  GARRET    *     ?  *
//                                                                    *   /\|  *
//                                                                    *  /  \  *
//      Lines & characters storages                Moscow, RUSSIA     * / [] \ *
//                                                                    * GARRET *
//--------------------------------------------------------------------*--------*
// Lines & characters storages
// Copyright (C) 1993 Garret.
//
// This file is part of IV - Garret Simple Text Editor
//
// IV is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// IV is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with IV; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
// $Id: estor.cpp,v 1.1.1.1 1995/10/04 20:35:49 abramow Exp $
//

#include "editr.hpp"

Line_Store::Line_Store() : Text() { Last = put; }

Line_Store::~Line_Store(){;}

void    Line_Store::Clear(){ Last = put; Text::Clear(); }

void    Line_Store::Put(Txt_String* Str){
    if(Last == get)
      { Clear(); Last = put; }
    Ins_Line(Used, new Txt_String(Str));
}

int    Line_Store::Get(Text* To, int Before){
    for(int i = Used; --i >= 0; To->Ins_Line(Before, new Txt_String(Txt[i])));
    Last = get;
    return Used;
}

Char_Store::Char_Store(){ Clear(); Last = put; }

void    Char_Store::Put(char c){
    if(Last == get)
      { Clear(); Last = put; }
    if(Used < STR_SIZE)
        Str[Used++] = c;
}

int     Char_Store::Get(Text* To, int Line, int Column){
    int i = STR_SIZE - Column;
    if(Used < i)
        i = Used;
    for(int k = 0; k < i; k += 1)
        To->Rep_Char(Line, Column++, Str[k]);
    Last = get;
    return i;
}

int     Char_Store::Ins(Text* To, int Line, int Column){
    int i = STR_SIZE - Column;
    if(Used < i)
        i = Used;
    for(int k = 0; k < i; k += 1)
        To->Ins_Char(Line, Column++, Str[k]);
    Last = get;
    return i;
}
