//-< ESTOR.HPP >------------------------------------------------------*--------*
// Garret Simple Text Editor                      (c) 1993  GARRET    *     ?  *
//                                                                    *   /\|  *
//                                                                    *  /  \  *
//      Lines and characters storages              Moscow, RUSSIA     * / [] \ *
//                                                                    * GARRET *
//--------------------------------------------------------------------*--------*
// Lines and characters storages
// Copyright (C) 1993 Garret.
//
// This file is part of IV - Garret Simple Text Editor
//
// IV is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// IV is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with IV; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
// $Id: estor.hpp,v 1.1.1.1 1995/10/04 20:35:49 abramow Exp $
//

#ifndef __ESTOR_HPP__
    #define __ESTOR_HPP__

    // Line storage
    class   Line_Store : private Text {
        enum { get, put }   Last;       // Last operation type

      public:
        Line_Store();
        ~Line_Store();

        // Make storage empty
        void    Clear();

        // Put string into storage
        void    Put(Txt_String* Str);

        // Place storage lines into text before specified line
        int     Get(Text* To, int Before);
    };

    // Character storage
    class   Char_Store : private Txt_String {
        enum { get, put }   Last;       // Last operation type
        int     Used;                   // Number of saved characters

      public :
        Char_Store();

        // Make storage empty
        void    Clear(){ Used = 0; }

        // Put character into storage
        void    Put(char c);

        // Place storage characters into specified text position
        //   in replace or insert mode
        int     Get(Text* To, int Line, int Column);
        int     Ins(Text* To, int Line, int Column);
    };

#endif
