//-< LOKBD.HPP >------------------------------------------------------*--------*
// Garret Simple Text Editor                      (c) 1993  GARRET    *     ?  *
//                                                                    *   /\|  *
//                                                                    *  /  \  *
//      Low level keyboard interface               Moscow, RUSSIA     * / [] \ *
//                                                                    * GARRET *
//--------------------------------------------------------------------*--------*
// Low level keyboard interface
// Copyright (C) 1993 Garret.
//
// This file is part of IV - Garret Simple Text Editor
//
// IV is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// IV is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with IV; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
// $Id: lokbd.hpp,v 1.1.1.1 1995/10/04 20:35:49 abramow Exp $
//

#ifndef __LOKBD_HPP__
    #define __LOKBD_HPP__

    // Descriptor of finite automatom edge
    struct  Key_Item    {
        int         From;               // Range of
        int         To;                 //    keystrokes
        Key_Item const* Next;           // Is really next automatom state
        void        (*Func)(int Key);   // Function to process keystroke
        int         Arg;                // Function argument characteristics
    };

    // Main state finite automatom table
    extern  const Key_Item    Main_Tbl[];

    // Get next keystroke
    extern  "C" int low_get(void* w);

    // Initialize keyboard
    extern  "C" int low_kbd_init();

    // Terminate keyboard
    extern  "C" int low_kbd_term();

    // Process keystroke (implemented in "input.cpp")
    extern  "C" void Edit(int i);

#endif
