//-< LOVID.HPP >------------------------------------------------------*--------*
// Garret Simple Text Editor                      (c) 1993  GARRET    *     ?  *
//                                                                    *   /\|  *
//                                                                    *  /  \  *
//      Low level video interface                  Moscow, RUSSIA     * / [] \ *
//                                                                    * GARRET *
//--------------------------------------------------------------------*--------*
// Low level video interface
// Copyright (C) 1993 Garret.
//
// This file is part of IV - Garret Simple Text Editor
//
// IV is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// IV is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with IV; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
// $Id: lovid.hpp,v 1.1.1.1 1995/10/04 20:35:49 abramow Exp $
//

#ifndef __LOVID_HPP__
    #define __LOVID_HPP__

    // Open the rectangular window of specified size
    extern  "C" void* low_Open(int bas_x, int bas_y, int max_x, int max_y);

    // Close window
    extern  "C" void  low_Close(void* w);

    // Set new cursor window position
    extern  "C" void  low_Pos(void* w, int Line, int Column);

    // Insert blank line
    extern  "C" void  low_Ins_Line(void* w, int Line);

    // Delete line
    extern  "C" void  low_Del_Line(void* w, int Line);

    // Insert blank space
    extern  "C" void  low_Ins_Char(void* w, int Line, int Column);

    // Delete character
    extern  "C" void  low_Del_Char(void* w, int Line, int Column);

    // Clear end of line
    extern  "C" void  low_Clr_Eol (void* w, int Line, int Column);

    // Put specified string into window
    extern  "C" void  low_Put(void* w, int Line, int Column, int Len,char* Str);

    // Bell
    extern  "C" void  low_Bell();

    // Show all changes in window on phisical screen
    extern  "C" void  low_Sync(void* w);

    // Copy the rectangular area
    extern  "C" void  low_Bit_Blit
                    (void* w, int y1, int x1, int y2, int x2, int y3, int x3);

#endif
