//-< VIDEO.CPP >------------------------------------------------------*--------*
// Garret Simple Text Editor                      (c) 1993  GARRET    *     ?  *
//                                                                    *   /\|  *
//                                                                    *  /  \  *
//      Viewer                                     Moscow, RUSSIA     * / [] \ *
//                                                                    * GARRET *
//--------------------------------------------------------------------*--------*
// Viewer
// Copyright (C) 1993 Garret.
//
// This file is part of IV - Garret Simple Text Editor
//
// IV is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// IV is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with IV; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
// $Id: video.cpp,v 1.1.1.1 1995/10/04 20:35:49 abramow Exp $
//

#include "editr.hpp"
#include "lovid.hpp"

View*   View::All_Views = NULL;

View::View() {
    Win = NULL;
    Next = All_Views;
    All_Views = this;
}

View::~View() {
    View**  vpp;
    View*   vp;

    Close();
    for(vpp = &All_Views; (vp = *vpp) != this; vpp = &vp->Next);
    *vpp = Next;
    if(Txt != NULL)
        Txt->Wnd = NULL;
}

int View::Open(int bas_x, int bas_y, int max_x, int max_y){
    Kbd_Init();
    Win_X = max_x; Win_Y = max_y;
    Txt_X = Txt_Y = Cur_X = Cur_Y = 0;
    Txt = NULL;
    return (Win = low_Open(bas_x, bas_y, max_x, max_y)) == NULL;
}

void    View::Close(){ if(Win != NULL) low_Close(Win); Win = NULL; }

void    View::Connect(Text* txt)
  { Txt = txt; txt->Wnd = this; }

void    View::Pos(int x, int y){
    if(Txt_Y > y)
        Set_Y(y);
    else if(Win_Y + Txt_Y <= y)
        Set_Y(y - Win_Y + 1);
    low_Pos(Win, y - Txt_Y, x - Txt_X);
}

void    View::Set_Y(int y){
    int  old_y = Txt_Y;
    Txt_Y = y;

    if(y < old_y){
        if((old_y - y) < Win_Y/2){
//            low_Bit_Blit(0, 0, , Win_X-1, 0, 0);
//            Redraw(0, Win_Y - (old_y - y));
            Redraw();
        } else
            Redraw();
    } else if(y > old_y){
        if((y - old_y) < Win_Y/2){
//            low_Bit_Blit(y - old_y, 0, Win_Y-1, Win_X-1, 0, 0);
//            Redraw(0, Win_Y - (y - old_y));
            Redraw();
        } else
            Redraw();
    }
}

void    View::Ins_Line(int Line){
    if(Line < Txt_Y || Line >= Txt_Y + Win_Y)
        return;
    low_Ins_Line(Win, Line - Txt_Y);
    Redraw(Line,1);
}

void    View::Del_Line(int Line){
    if(Line < Txt_Y || Line >= Txt_Y + Win_Y)
        return;
    low_Del_Line(Win,Line - Txt_Y);
    Redraw(Txt_Y + Win_Y - 1,1);
}

void    View::Ins_Char(int Line, int Column){
    if(Line < Txt_Y || Line >= Txt_Y + Win_Y)
        return;
    low_Ins_Char(Win,Line - Txt_Y, Column - Txt_X);
    low_Put(Win,Line - Txt_Y, Column - Txt_X, 1, Txt->Txt[Line]->Str + Column);
}

void    View::Del_Char(int Line, int Column){
    if(Line < Txt_Y || Line >= Txt_Y + Win_Y)
        return;
    low_Del_Char(Win,Line - Txt_Y, Column - Txt_X);
    low_Put(Win,Line-Txt_Y, Win_X - 1, 1, Txt->Txt[Line]->Str + STR_SIZE - 1);
}

void    View::Rep_Char(int Line, int Column){
    if(Line < Txt_Y || Line >= Txt_Y + Win_Y)
        return;
    low_Put(Win,Line - Txt_Y, Column - Txt_X, 1, Txt->Txt[Line]->Str + Column);
}

void    View::Bell(){ low_Bell(); }

void    View::Redraw(){ Redraw(Txt_Y, Win_Y); }

void    View::Redraw(int Line, int n){
    for(int i = 0; i < n; i += 1){
        if(Line + i >= Txt->Used)
            low_Clr_Eol(Win,Line - Txt_Y + i, 0);
        else
            low_Put(Win,Line - Txt_Y + i, 0, STR_SIZE, Txt->Txt[Line + i]->Str);
    }
}

void    View::Sync(){ low_Sync(Win); }

void    View::Redraw_All(){
    for(View* v = All_Views; v != NULL; v = v->Next)
        { v->Redraw(); v->Sync(); }
}
