//-< VIDEO.HPP >------------------------------------------------------*--------*
// Garret Simple Text Editor                      (c) 1993  GARRET    *     ?  *
//                                                                    *   /\|  *
//                                                                    *  /  \  *
//      Viewer                                     Moscow, RUSSIA     * / [] \ *
//                                                                    * GARRET *
//--------------------------------------------------------------------*--------*
// Viewer
// Copyright (C) 1993 Garret.
//
// This file is part of IV - Garret Simple Text Editor
//
// IV is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// IV is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with IV; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
// $Id: video.hpp,v 1.1.1.1 1995/10/04 20:35:49 abramow Exp $
//

#ifndef __VIDEO_HPP__
    #define __VIDEO_HPP__

    // Forward declaration
    class   Text;

    // Viewer
    class   View {
        int     Win_X,  Win_Y;          // Window sizes
        int     Txt_X,  Txt_Y;          // Position of window left top corner
                                        //   in the text
        int     Cur_X,  Cur_Y;          // Cursor location in the window
        Text*   Txt;                    // Text
        void*   Win;                    // Window

        friend  void    Proc_Key();

        View*   Next;                   // Next viewer
        static  View*   All_Views;      // List of all viewers

      public :
         View();
        ~View();

        // Open viewer window
        int     Open(int bas_x, int bas_y, int max_x, int max_y);

        // Close window
        void    Close();

        // Connect specified text with window
        void    Connect(Text* txt);

        // Set cursor to specified text position
        void    Pos(int x, int y);

        // Insert line in text before specified
        void    Ins_Line(int Line);

        // Delete specified line in text
        void    Del_Line(int Line);

        // Insert blank space into specified text position
        void    Ins_Char(int Line, int Column);

        // Delete character from specified text position
        void    Del_Char(int Line, int Column);

        // Replace character in specified text position
        void    Rep_Char(int Line, int Column);

        // Bell
        void    Bell();

        // Scroll text to place y-th text line at the top of the window
        void    Set_Y(int y);

        // Redraw the whole window
        void    Redraw();

        // Redraw n lines of window starting from y
        void    Redraw(int y, int n);

        // Redraw all windows
        static  void    Redraw_All();

        // Show all changes in window
        void    Sync();

        // Get window height
        int     Get_Win_Y(){ return Win_Y; }

        // Get top window line number in the text
        int     Get_Txt_Y(){ return Txt_Y; }
    };

#endif
