/*-< SWI86.S   >-----------------------------------------------------*--------*
 * Garret class library.    Version 2.0           (c) 1994  GARRET   *     ?  *
 * Simple synchronous processes ( really coroutines )                *   /\|  *
 *                                                                   *  /  \  *
 *                                                                   * / [] \ *
 *                                                                   * GARRET *
 *-------------------------------------------------------------------*--------*
 * Edit history:
 *                          Last update:
 */
/*
 *      export  int             Tsk_Stack_Size( void );
 *      export  int             Tsk_Save_Stack( void* Stk );
 *      export  noret   void    Tsk_Load_Stack( const void* Stk, int R_Code );
 */

#if defined(__svr4__) || defined (__ELF__)
#define _Tsk_Stack_Base 	Tsk_Stack_Base
#define _Tsk_Save_Ret_Value 	Tsk_Save_Ret_Value
#define _Tsk_Stack_Size         Tsk_Stack_Size
#define _Tsk_Save_Stack         Tsk_Save_Stack
#define _Tsk_Load_Stack		Tsk_Load_Stack
#endif

        .globl  _Tsk_Stack_Base
        .globl  _Tsk_Save_Ret_Value
        .globl  _Tsk_Stack_Size

_Tsk_Stack_Size:
        movl    _Tsk_Stack_Base,%eax
        subl    %esp, %eax
        addl    $120,%eax
        ret

        .globl  _Tsk_Save_Stack
_Tsk_Save_Stack:
	pushl   %ebp
        movl    %esp, %ebp
 	pushl	%esi
	pushl	%edi
	pushl	%ebx
	pushl	%edx
	pushl	%ecx  
        movl    8(%ebp), %edi
	movl	%esp,	(%edi)
	addl	$4,	%edi
	movl	%esp,	%esi
	movl	_Tsk_Stack_Base, %ecx
	subl	%esi,	%ecx  
	cld
	rep
	movsb   
	popl	%ecx
	popl	%edx
	popl	%ebx
	popl	%edi
	popl	%esi
	popl	%ebp
        movl    _Tsk_Save_Ret_Value,%eax
        ret

        .globl  _Tsk_Load_Stack
_Tsk_Load_Stack:
	popl	%eax			/* skip return address */
	popl	%esi			/* get address of save area */ 
	popl	%eax			/* get return value */
        movl	(%esi),  %esp		/* restore new sp value */
	addl	$4,	%esi		/* promote save area pointer */
	movl	_Tsk_Stack_Base, %ecx	/* calculate number of iterations*/
	movl	%esp,	%edi		/* load address of destination area*/
	subl	%edi,	%ecx
	cld
	rep
	movsb				/* block mode copy*/
	popl	%ecx
	popl	%edx
	popl	%ebx
	popl	%edi
	popl	%esi
	popl	%ebp
	ret




