;;-< SW80X86.ASM >----------------------------------------------------*--------*
;;                          Version 1.0           (c) 1992  GARRET    *     ?  *
;;                                                                    *   /\|  *
;;                                                                    *  /  \  *
;;                          Created:        15-SEP-1992  V.V. Model   * / [] \ *
;;                          Last update:    16-SEP-1992  V.V. Model   * GARRET *
;;--------------------------------------------------------------------*--------*
;; Edit history:
;;                          Last update:
;;
;;
;;      export  long            Tsk_Stack_Size( void );
;;      export  int             Tsk_Save_Stack( void* Stk );
;;      export  noret   void    Tsk_Load_Stack( const void* Stk, int R_Code );
;;

_DATA segment byte public 'DATA'
        extrn   _Tsk_Stack_Base         :   dword
        extrn   _Tsk_Save_Ret_Value     :   word
_DATA ends

CTXSW_TEXT segment byte public 'CODE'
assume cs:CTXSW_TEXT, ds:_DATA

;-------------------------------------------------------------------------------
;
;-------------------------------------------------------------------------------
public _Tsk_Stack_Size
_Tsk_Stack_Size proc far
            push    ds
            mov     ax, seg _Tsk_Stack_Base
            mov     ds, ax
            mov     dx, ss
            sub     dx, word ptr _Tsk_Stack_Base[2]
            mov     word ptr _Tsk_Stack_Base[2], ss
            mov     cl, 4
            sal     dx, cl
            sub     word ptr _Tsk_Stack_Base, dx
            and     byte ptr _Tsk_Stack_Base, 0feh
            mov     ax, word ptr _Tsk_Stack_Base
            pop     ds
            sub     ax, sp
            add     ax, 32
            xor     dx, dx
            retf
_Tsk_Stack_Size endp

;-------------------------------------------------------------------------------
;
;-------------------------------------------------------------------------------
public _Tsk_Save_Stack
_Tsk_Save_Stack proc far
            push    si di bp es ds ss
            mov     ax, seg _Tsk_Stack_Base
            mov     ds, ax
            mov     cx, word ptr _Tsk_Stack_Base
            mov     si, sp          ; SS:SI pointer to the stack frame.
            les     di, ss:16[si]   ; Buffer to recieve the stack image.
            cld
            mov     ax, si
            stosw
            mov     ax, _Tsk_Save_Ret_Value
            mov     bx, ss
            mov     ds, bx          ; DS:SI pointer to the stack frame.
            sub     cx, si          ; Lenght of the stack image is to be saved.
            shr     cx, 1
        rep movsw
            add     sp, 2           ; pop   ss
            pop     ds es bp di si
            retf
_Tsk_Save_Stack endp

;-------------------------------------------------------------------------------
;
;-------------------------------------------------------------------------------
public _Tsk_Load_Stack
_Tsk_Load_Stack proc far
            cli                     ; We needn't to save any register, because
            cld                     ; we shan't come back to caller.
            mov     bp, sp
            mov     ax, seg _Tsk_Stack_Base
            mov     ds, ax
            mov     cx, word ptr _Tsk_Stack_Base
            lds     si, 4[bp]       ; Buffer contains saved stack image.
            lodsw                   ; Load the address.
            mov     di, ax          ; Offset on the stack.
            mov     sp, ax
            sub     cx, ax          ; Lenght of saved stack image.
            mov     ax, [si]        ; Load SS value.
            mov     ss, ax
            mov     es, ax          ; ES:DI - address on the stack.
            mov     ax, 8[bp]       ; Value is to be returned.
            shr     cx, 1
        rep movsw
            add     sp, 2           ; pop   ss
            pop     ds es bp di si
            sti
            retf
_Tsk_Load_Stack endp

CTXSW_TEXT ends
end
