/*-< SW68K.S   >-----------------------------------------------------*--------*
 * Garret class library.    Version 2.0           (c) 1992  GARRET   *     ?  *
 * Simple synchronous processes ( really coroutines )                *   /\|  *
 *                                                                   *  /  \  *
 *                                                                   * / [] \ *
 *                                                                   * GARRET *
 *-------------------------------------------------------------------*--------*
 * Edit history:
 *                          Last update:
 */
/*
 *      export  int             Tsk_Stack_Size( void );
 *      export  int             Tsk_Save_Stack( void* Stk );
 *      export  noret   void    Tsk_Load_Stack( const void* Stk, int R_Code );
 */
        .globl  _Tsk_Stack_Base
        .globl  _Tsk_Save_Ret_Value
        .globl  _Tsk_Stack_Size

_Tsk_Stack_Size:
        movl    _Tsk_Stack_Base,d0
        subl    sp,d0
        addl    #120,d0
        rts

        .globl  _Tsk_Save_Stack
_Tsk_Save_Stack:
        movl    sp@(4), a0
        movl    a6,     a0@(12)         /* save frame pointer of caller */
        movl    sp@+,   a1              /* pop return address */
        movl    a1,     a0@(4)          /* save pc of caller */
        movl    sp,     a0@(8)
        moveml  #0xBCFC,a0@(40)         /* XXX (shouldn't need this) XXX */
        movl    sp,     a2
        movl    _Tsk_Stack_Base,d1
        movl    a0,     a4
        addl    #110,   a4
        subl    a2,     d1
        asrl    #2,     d1
Lrep1:  movl    a2@+,   a4@+
        dbra    d1,     Lrep1
        movl    a4,     d0              /* New pointer */
        subl    a2,     d0              /* Minus old pointer */
        movl    d0,     a0@             /* is the relocation offset */
        moveml  a0@(40),#0xBCFC         /* XXX (shouldn't need this) XXX */
        movl    _Tsk_Save_Ret_Value,d0
        jmp     a1@

        .globl  _Tsk_Load_Stack
_Tsk_Load_Stack:
        movl    sp@(8), d0              /* return value */
        movl    sp@(4), a0              /* fetch buffer */

        movl    a0@(8), sp
        movl    sp,     a2
        movl    _Tsk_Stack_Base,d1
        movl    a0,     a4
        addl    #110,   a4
        subl    a2,     d1
        asrl    #2,     d1
Lrep2:  movl    a4@+,   a2@+
        dbra    d1,     Lrep2
        moveml  a0@(40),#0xBCFC         /* XXX (shouldn't need this) XXX */
        movl    a0@(12),a6              /* restore frame pointer */
        movl    a0@(4), a1              /* pc */
        jmp     a1@
