//-< STRMS.CPP >------------------------------------------------------*--------*
// Abstract strem           Version 1.0           (c) 1992  GARRET    *     ?  *
//                                                                    *   /\|  *
//                                                                    *  /  \  *
//                                                                    * / [] \ *
//                                                                    * GARRET *
//--------------------------------------------------------------------*--------*
// Edit history:
//                          Last update:

#include "strms.hpp"

//
// Implementation of stream from the file
//

String * File_Stream::Gets ()  {
  if ( fgets ( Buf->Str , Size , File ) == NULL ) return NULL ;
  Buf->Len = strlen ( Buf->Str ) ;
  while ( Buf->Str[Buf->Len-2] != '\n' )   {
     Realloc () ;
     if ( fgets(Buf->Str+Buf->Len, Size-Buf->Len, File)==NULL ) return NULL;
     Buf->Len = strlen ( Buf->Str ) ;
  }
  return Buf ;
}

String * File_Stream::Cat ()  {
  if ( fgets(Buf->Str+Buf->Len, Size-Buf->Len, File)==NULL ) return NULL;
  Buf->Len = strlen ( Buf->Str ) ;
  while ( Buf->Str[Buf->Len-2] != '\n' )   {
     Realloc () ;
     if ( fgets(Buf->Str+Buf->Len, Size-Buf->Len, File)==NULL ) return NULL;
     Buf->Len = strlen ( Buf->Str ) ;
  }
}

String * Puts ( String * Str )
  { return fputs ( Str->Str , File ) != NULL ? Str : NULL ; }

//
// Implementation of stream from simple string
//

int Str_Stream::Putc ( int ch ) {
  if ( Cur >= Str->Len )  {
     if ( Cur >= Size ) Realloc () ;
     Str->Len += 1 ;
  }
  Buf->Str[Cur++] = ch ;
  return ch ;
}

int Str_Stream::Ungetc ( int ch ) {
  ASSERT ( Cur > 0 ) ;
  Buf->Str[--Cur] = ch ;
  return ch ;
}

String * Str_Stream::Puts ( String * Str )  {
  if ( Str->Len > Size ) Expand ( Str->Len ) ;
  memcpy ( Buf->Str , Str->Str , Str->Len ) ;
  Buf->Len = Str->Len ;
  Cur = 0 ;
}

String * Str_Stream::Cat ( String * Str )  {
  while ( Str->Len + Buf->Len > Size )  Realloc () ;
  memcpy ( Buf->Str + Buf->Len , Str->Str , Str->Len ) ;
  Buf->Len += Str->Len ;
  Cur = 0 ;
}
