#ifndef __STRNG_HPP__
    #define __STRNG_HPP__

    #define Str_Size( x )   ( (int)(((String*)0)->Str) + 1 + ( x ) )
    #define Str_New( x )    ((String*)( Dnm_Get_Block( Str_Size(x) )))

    struct  String  {                           // Generic structure to handle
        struct      String*         Next;       // Variable length records
        nat         Length;
        char        Str[ 1 ];

        String* proc operator+( String& p );
        String* Dup( void );
        bool    proc operator==( String& p );
        void    proc Str_Kill( void )
                    { Dnm_Fre_Block( (void*)this ); };
    };

    export  String* proc    Str_Cat( String* p, String* q );
    export  String* proc    New_String( char* p );

    //--------------------------------------------------------------------------

    class   Str_Iterator {      // Class to be used to iterate throw the string
        String*     Curr;       // Pointer to current string block
        nat         Left;       // Number of characters left
        char*       Symb;       // Pointer to current character
    public  :

        Str_Iterator( String* s ){
            Curr = s;
            Left = s->Length;
            Symb = s->Str;
        };

        bool    EOS( void ){
            return  Left == 0 && Curr->Next == NULL;
        };

        char*   Sym( void ){
            return  Symb;
        };

        void    operator++(){

            if( Left == 0 ){
                if( Curr != NULL ){
                    Curr = Curr->Next;
                    Left = Curr->Length;
                    Symb = Curr->Str;
                }
            } else {
                Left -= 1;
                Symb += 1;
            }
        };
    };

    //--------------------------------------------------------------------------

    class   Str_Stack : public Dnm_Stack   {
    public  :
        Str_Stack( void ) : Dnm_Stack( BFR_ALLOC ) {;};

        void    Restart( void ) {
            Dnm_Stack::Restart();
        };

        String* proc Push( nat Size, char* p ){
            String* s  =  (String*)(Dnm_Stack::Push( Str_Size( Size ) ) );

            s->Length = Size;
            s->Next = NULL;
            memcpy( s->Str, p, Size );
            return  s;
        };
    };

    //--------------------------------------------------------------------------

    class   Str_Table : public Str_Stack   {
        String*     Chain;
    public  :
        Str_Table( void ) { Chain = NULL; };

        void    Restart( void ) {
            Chain = NULL;
            Str_Stack::Restart();
        };

        String* proc Push( nat Size, char* p );
    };
#endif
