#ifndef __MMLIB_HPP__
#define __MMLIB_HPP__
//-----------------------------------------------------------------------------
//   Emulation of ANSI C memory allocator
//   Copyright (C) 1995 Garret
//
// This file is part of Garret C-Talk.
//
// Garret C-Talk is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// Garret C-Talk is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Garret C-Talk; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//-----------------------------------------------------------------------------

#undef malloc
#undef calloc
#undef realloc
#undef free

extern  "C" void*	malloc(size_t size);
extern  "C" void*	calloc(size_t N, size_t size);
extern  "C" void*	realloc(void* oldp, size_t size);
extern  "C" void	free(void* p);

extern  "C" void*	valloc(size_t size);

//-----------------------------------------------------------------------------

extern  "C" void*	xmalloc(size_t size);
extern  "C" void*	xcalloc(size_t N, size_t size);
extern  "C" void*	xrealloc(void* oldp, size_t size);

//-----------------------------------------------------------------------------

struct	rtm_mem_free_slot {
    rtm_mem_free_slot*	next;	// The only thing we can place in free slot
				// for sure, is one pointer --- pointer to 
				// the next free slot (or NULL if no such 
				//  slot exists)
};

struct	rtm_mem_slot_page {
    short		s_size;	// Slot size
    short		n_used;	// Number of used slots
    rtm_mem_slot_page*	p_prev;	// 
    rtm_mem_slot_page*	p_next; // 
    rtm_mem_free_slot*	s_free; // Header of free slots queue
    rtm_mem_free_slot	b[1];	// Pool of free slots (it's actually longer)
};

struct	rtm_mem_page_queue {
    rtm_mem_free_slot*	f_slot;	// Header of free slots queue
    rtm_mem_slot_page*	f_page;	// Current free page (under loading)
    int			n_slots; // Number of slots in page 
    short		s_size;	// Size of each slot
};

#endif
