//-< INLIN.HPP >-----------------------------------------------------*--------*
// Garret Object Class Library                    (c) 1993  GARRET   *     ?  *
//                                                                   *   /\|  *
//  Inline vesions of memory manipulation functions                  *  /  \  *
//                           Created:      27-Aug-92   K.A. Knischnik* / [] \ *
//    Declarations           Last update:                            * GARRET *
//-------------------------------------------------------------------*--------*

#ifndef __INLIN_HPP__
    #define __INLIN_HPP__

    inline void bcpy ( char* dst, const char* src, int len ) {
       while ( -- len >= 0 ) *dst++ = *src++;
    }
    inline void scpy ( short* dst, const short* src, int len ) {
       while ( -- len >= 0 ) *dst++ = *src++;
    }
    inline void lcpy ( long* dst, const long* src, int len ) {
       while ( -- len >= 0 ) *dst++ = *src++;
    }
    inline void pcpy ( void* d, const void* s, int len ) {
       void **dst = (void**)d, **src = (void**)s;
       while ( -- len >= 0 ) *dst++ = *src++;
    }

    inline void bset ( char* dst, char pat, int len ) {
       while ( -- len >= 0 ) *dst++ = pat;
    }
    inline void sset ( short* dst, short pat, int len ) {
       while ( -- len >= 0 ) *dst++ = pat;
    }
    inline void lset ( long* dst, long pat, int len ) {
       while ( -- len >= 0 ) *dst++ = pat;
    }
    inline void pset ( void* d, void* pat, int len ) {
       void** dst = (void**)d;
       while ( -- len >= 0 ) *dst++ = pat;
    }

    inline void bzero ( char* dst, int len ) {
       while ( -- len >= 0 ) *dst++ = 0;
    }
    inline void szero ( short* dst, int len ) {
       while ( -- len >= 0 ) *dst++ = 0;
    }
    inline void lset ( long* dst, int len ) {
       while ( -- len >= 0 ) *dst++ = 0;
    }
    inline void pset ( void* d, int len ) {
       void** dst = (void**)d;
       while ( -- len >= 0 ) *dst++ = (void*)0;
    }

    inline char bcmp ( const char* dst, const char* src, int len ) {
       while ( -- len >= 0 )
          if ( *dst++ != *src++ ) return *--dst - *--src;
       return 0;
    }
    inline short scmp ( const short* dst, const short* src, int len ) {
       while ( -- len >= 0 )
          if ( *dst++ != *src++ ) return *--dst - *--src;
       return 0;
    }
    inline long lcmp ( const long* dst, const long* src, int len ) {
       while ( -- len >= 0 )
          if ( *dst++ != *src++ ) return *--dst - *--src;
       return 0;
    }
    inline int  pcmp ( const void* d, const void* s, int len ) {
       char **dst = (char**)d, **src = (char**)s;
       while ( -- len >= 0 )
          if ( *dst++ != *src++ ) return *--dst - *--src;
       return 0;
    }

#endif

