//-< NUMLB.HPP >------------------------------------------------------*--------*
// Garret Object Class Library                    (c) 1992  GARRET    *     ?  *
//                                                                    *   /\|  *
//  Integer numbers  library                                          *  /  \  *
//                           Created:      17-Mar-92   I.V. Abramow   * / [] \ *
//    Declarations           Last update:  17-Mar-92   I.V. Abramow   * GARRET *
//--------------------------------------------------------------------*--------*

#ifndef __NUMLB_HPP__
    #define __NUMLB_HPP__

    export  large proc gcd( large x, large y );
    export  large proc gcd( long  x, long  y );
    inline  large      lcm( large x, large y )
        { return ( x/gcd( x, y ) ) * y; }
    inline  large      lcm( long  x, long  y )
        { return ( x/gcd( x, y ) ) * y; }

    #define MAX_FIB_IN_LONG     47
    export  large   Fib_Numb[ MAX_FIB_IN_LONG ];

    inline  char        abs( char  a )
        { return a >= 0 ? a : -a ; }
    inline  short       abs( short a )
        { return a >= 0 ? a : -a ; }
    inline  long        abs( long  a )
        { return a >= 0 ? a : -a ; }

    inline  char        max( char a, char b )
        { return a > b ? a : b; }
    inline  tiny        max( tiny a, tiny b )
        { return a > b ? a : b; }
    inline  short       max( short a, short b )
        { return a > b ? a : b; }
    inline  nat         max( nat   a, nat   b )
        { return a > b ? a : b; }
    inline  int         max( int   a, int   b )
        { return a > b ? a : b; }
    inline  unsigned    max( unsigned a, unsigned b )
        { return a > b ? a : b; }
    inline  long        max( long  a, long  b )
        { return a > b ? a : b; }
    inline  large       max( large a, large b )
        { return a > b ? a : b; }

    inline  char        min( char a, char b )
        { return a < b ? a : b; }
    inline  tiny        min( tiny a, tiny b )
        { return a < b ? a : b; }
    inline  short       min( short a, short b )
        { return a < b ? a : b; }
    inline  nat         min( nat   a, nat   b )
        { return a < b ? a : b; }
    inline  int         min( int   a, int   b )
        { return a < b ? a : b; }
    inline  unsigned    min( unsigned a, unsigned b )
        { return a < b ? a : b; }
    inline  long        min( long  a, long  b )
        { return a < b ? a : b; }
    inline  large       min( large a, large b )
        { return a < b ? a : b; }

    inline  void        maxasg( char& a, char b )
        { if( a < b ) a = b; }
    inline  void        maxasg( tiny& a, tiny b )
        { if( a < b ) a = b; }
    inline  void        maxasg( short& a, short b )
        { if( a < b ) a = b; }
    inline  void        maxasg( nat& a, nat b )
        { if( a < b ) a = b; }
    inline  void        maxasg( int& a, int b )
        { if( a < b ) a = b; }
    inline  void        maxasg( long& a, long b )
        { if( a < b ) a = b; }
    inline  void        maxasg( large& a, large b )
        { if( a < b ) a = b; }

    inline  void        minasg( char& a, char b )
        { if( a > b ) a = b; }
    inline  void        minasg( tiny& a, tiny b )
        { if( a > b ) a = b; }
    inline  void        minasg( short& a, short b )
        { if( a > b ) a = b; }
    inline  void        minasg( nat& a, nat b )
        { if( a > b ) a = b; }
    inline  void        minasg( int& a, int b )
        { if( a > b ) a = b; }
    inline  void        minasg( long& a, long b )
        { if( a > b ) a = b; }
    inline  void        minasg( large& a, large b )
        { if( a > b ) a = b; }

    #define     ALIGN( x, p )   (((x)+((p)-1))&~((p)-1))
#endif
