//
//-< STDTP.HPP >-----------------------------------------------------*--------*
// Super C integrated environment                 (c) 1991  GARRET   *     ?  *
//  Standart types definitions for portable C programming            *   /\|  *
//  and style improving                                              *  /  \  *
//                           Created:      01-AUG-89   I.V. Abramow  * / [] \ *
//                           Last update:  10-Jun-95   I.V. Abramow  * GARRET *
//-------------------------------------------------------------------*--------*

#ifndef __STDTP_HPP__
    #define __STDTP_HPP__

    #include    <limits.h>
    #include    <stddef.h>
    #include    "config.hpp"

#if __GNUC_MINOR__ < 6
typedef int     bool;           // Introduce boolean type for more readability
#endif
typedef unsigned char   tiny;   // Integer for small values
typedef unsigned short  nat;    // Medium sized unsigned integer value
typedef char            byte;
typedef short           word;
typedef unsigned long   large;

#define TRUE    1               // Values for bool type
#define FALSE   0

#define ON      1               // Another representation of boolean values
#define OFF     0               // for some flag variables

#define YES     1               // Another representation of boolean values
#define NO      0              
 
// introduce new pseudokeywords
#define	global
#define	export	extern
#define	import	extern
#define	local	static
#define	proc	pascal

#ifndef __MSDOS__
    #define noret       volatile
#else
    #define noret
#endif

#define nobreak

//----< If compiler does not support pointer range keywords -- hide them >

#if !defined( __MSDOS__ )
    #define near
    #define far
    #define huge
    #define pascal
#endif

#define class           class   huge
#define struct          struct  huge
#define union           union   huge

// Exit codes

#define EX_O_KEY    0           // Successfully comletion
#define EX_WARNINGS 1           // User warned, terminated normally
#define EX_ERRORS   2           // User is somewhere wrong, terminated normally
#define EX_FATAL    3           // User is very wrong, abandon
#define EX_ABZAC    4           // Internal error detected

// Function Level Exception Handler Definitions

#define RAISE       goto        // To raise exception x type "RAISE x;"
#define EXCEPTION               // To mark exception handler - "EXCEPTION x:"

#define BIT_MNEM( x )   #x, x

#define HOST_CPU    TARGET_CPU

#define   items(Array)   	(sizeof Array/sizeof *Array)
#define   max_type_value(type)  ((1L << (sizeof(type)*8)) - 1)

#endif
