// This program tests whether Tsk_Stack_Size() is producing reasonable
// results.

#include <stdio.h>
#include <stdlib.h>

#include "stdtp.hpp"
#include "ctxsw.hpp"
#include "ermsg.hpp"

void  f () {
    int s, t;
    char buf[100];

    s = Tsk_Stack_Size();
    if( s < 100 || s > 100000 ) {
        Trace( "There seems to be a problem [1] with Tsk_Stack_Size().\n" );
        exit( 1 );
    }
    (void)alloca(100);
    t = Tsk_Stack_Size();
    if( t < s ) {
        Trace( "There seems to be a problem [2] with Tsk_Stack_Size().\n" );
        exit( 1 );
    }
    if( t > s + 104 ) {
        Trace(
          "There seems to be a problem with Tsk_Stack_Size() or alloca().\n" );
        exit( 1 );
    }
}

int main () {
    char foo;

    Tsk_Stack_Base = &foo;
    f();
    Trace( "Tsk_Stack_Size() seems to work fine.\n" );
    exit( 0 );
}

