#include    <signal.h>
#include    <sys/types.h>
#include    <time.h>
#include    "stdtp.hpp"
#include    "ermsg.hpp"
#include    "timer.hpp"

extern  "C" int    alarm(int);
static  time_t  next_wakeup;
static  bool    sig_flag = FALSE;

static  void  sig_handler(int){
  int i;

  if ((i = time(NULL) - next_wakeup) < tmr_block::head->delay)
     i = tmr_block::head->delay;
  if (Task_Critical) {
     Critical_Request = i;
  } else {
     tmr_proc_event(i);
  }
  signal(SIGALRM, sig_handler);
}

void  tmr_proc_event(int ticks){
  tmr_event(ticks);
  if (tmr_block::head != NULL) {
      int rest = tmr_block::head->delay;
      next_wakeup = time(NULL) + rest;
      alarm(rest);
  }
}

void  tmr_remove_event(void* block){
  tmr_rem_event(block);
  if (tmr_block::head == NULL)
      alarm(0);
  else {
      time_t    t0;
      int       rest;

      t0 = time(NULL);
      if ((rest = next_wakeup - t0) < 0)
          rest = 0;
      tmr_block::head->delay = rest;
      next_wakeup = t0 + rest;
      alarm(rest);
  }
}

void* tmr_setup_event(int delay, void (*func)(void*), void* arg){
  void*     v;
  int       rest;
  time_t    t0;

  t0 = time(NULL);
  if (tmr_block::head != NULL) {
      if ((rest = next_wakeup - t0) < 0)
          rest = 0;
      tmr_block::head->delay = rest;
      if (rest > delay) {
          alarm(delay);
          next_wakeup = t0 + delay;
      } else
          next_wakeup = t0 + rest;
  } else {
      next_wakeup = t0 + delay;
      alarm(delay);
  }
  v = tmr_set_event(delay, func, arg);
  if (!sig_flag) {
      sig_flag = TRUE;
      signal(SIGALRM, sig_handler);
  }
  return v;
}
