//-----------------------------------------------------------------------

extern void* tmr_set_event(int delay, void (*func)(void*), void* arg);
extern void  tmr_rem_event(void* block);
extern void  tmr_event(int ticks);

extern void  tmr_remove_event(void* block);
extern void* tmr_setup_event(int delay, void (*func)(void*), void* arg);
extern void  tmr_proc_event(int ticks);

extern int   Task_Critical;
extern int   Critical_Request;

//-----------------------------------------------------------------------------

struct   tmr_block {
    friend void* tmr_set_event(void (*func)(void*), void* arg);
    friend void  tmr_rem_event(void* block);
    friend void  tmr_event(int ticks);

    tmr_block*  next;           // Pointer to next block in timer event queue
    int         delay;          // Difference time between this and prev block
    void        (*func)(void*); // Hook function to be called on timer event
    void*       arg;            // Argument to hook function

    static  tmr_block*  head;   // Header of all timer blocks in queue
};
