#include "stdtp.hpp"
#include "timer.hpp"

extern "C" void abort();

//-----------------------------------------------------------------------------

tmr_block* tmr_block::head = NULL;

//-----------------------------------------------------------------------------

void* tmr_set_event(int delay, void (*func)(void*), void* arg){
  tmr_block** tpp;
  tmr_block*  tp;
  tmr_block*  tpa;

  // create block and fill some of its fields
  tpa = new tmr_block;
  tpa->next = NULL;
  tpa->func  = func;
  tpa->arg   = arg;

  // find right position for new block in list and adjust value of delay
  for(tpp = &tmr_block::head; (tp = *tpp) != NULL; tpp = &tp->next){
      if(tp->delay > delay){
          tp->delay -= delay;
          tpa->next = tp;
          break;
      } else
          delay -= tp->delay;
  }

  // link block into the list with proper delay value
  *tpp = tpa;
  tpa->delay = delay;

  return (void*)tpa;
}

//-----------------------------------------------------------------------------

void tmr_rem_event(void* block){
  tmr_block** tpp;
  tmr_block*  tp;

  for (tpp = &tmr_block::head; (tp = *tpp) != NULL; tpp = &tp->next) {
      if ((void*)tp == block) {
          *tpp = tp->next;
          return;
      }
  }
  abort();
}

//-----------------------------------------------------------------------------

void tmr_event(int ticks){
  tmr_block*    tp;
  tmr_block**   tpp;
  tmr_block*    run_list;

  for (tpp = &tmr_block::head; (tp = *tpp) != NULL; tpp = &tp->next) {
      if (ticks < tp->delay) {
          tp->delay -= ticks;
          break;
      }
      ticks -= tp->delay;
  }

  *tpp = NULL;
  run_list = tmr_block::head;
  tmr_block::head = tp;

  while (run_list != NULL) {
      run_list->func(run_list->arg);
      tp = run_list;
      run_list = run_list->next;
      delete tp;
  }
}
