//-----------------------------------------------------------------------------
// C-Talk programming environment.                     (C) 1993 Garret
//  System Library
//   Symbols
//    Primitives implementation
// $Source: /usr/users/cvs-root/mtalk/ctalk/lib/sys/ctype.cpp,v $
// $Id: ctype.cpp,v 1.1.1.1 1995/10/04 20:35:44 abramow Exp $
//-----------------------------------------------------------------------------

#include    "ctalk.hpp"
#include    "ctype.hpp"

global  void    wstrtoupper(nat2* p, nat4 len){
    while(len != 0){
        *p = to_upper(*p);
        len -= 1;   p += 1;
    }
}

global  void    wstrtolower(nat2* p, nat4 len){
    while(len != 0){
        *p = to_lower(*p);
        len -= 1;   p += 1;
    }
}

global  void    wstrcap(nat2* p, nat4 len){
    while(len > 0){
        while(len > 0 && !is_alnum(*p))
          { len -= 1; p += 1; }
        if(len > 0){
            *p = to_upper(*p); p += 1; len -= 1;
            while(len > 0 && is_alnum(*p)){
                *p = to_lower(*p);
                len -= 1; p += 1;
            }
        }
    }
}

global  void    wstrcset(nat2* p, tiny Cset, nat4 len){
    while(len > 0){
        len -= 1;
        *p = (*p & 0xFF) | (Cset << 8);
    }
}

global  int     wstrcmp(nat2 const* p, nat4 lenp, nat2 const* q, nat4 lenq){
    nat4        l = lenp > lenq ? lenp : lenq;

    while(l > 0){
        l -= 1;
        if(get_order(*p) != get_order(*q)){
            if(get_order(*p) > get_order(*q)) return 1;
            return -1;
        }
    }
    if(lenp == lenq) return 0;
    if(lenp < lenq)  return -1;
    return 1;
}

global  void    wstrtostr(char* p, nat2 const* q, nat4 len){
    while(len > 0){
        *p++ = (char)(*q++);
        len -= 1;
    }
}

global  void    strtowstr(nat2* p, char const* q, tiny Cset){
    nat2  a;

    while((a = (*q++) & 0xff) != 0)
        *p++ = a | (Cset << 8);
}

// Standard wstring <-> string conversions:
//
// Encoding is done by shift-states for character sets
//  <0xff> <cset + 1>
//

global  int4    wstrlen(char const* p){
    char const* q;
    int4        i;
    tiny        c;

    q = p; i = 0;
    while((c = *(tiny*)q++) != 0){
        if(c == 0xff){
             if(!*q++)
                 return -1;
             i += 2;
        }
    }
    return q - p - i;
}

global  int4    strwlen(nat2 const*)
{
	 return 0; 
}

global  int4    cnvwtos(char*, nat2 const*, int4 )
{
        return 0;
}

global  int4    cnvstow(nat2* , char const* )
{
        return 0;
}

global  char    const   Gsm_Sym_Attr    [GSM_MAX_SYMB] = {
// Latin-1      0x00
    0x00,_gsS,_gsS,_gsS,_gsS,_gsS,_gsS,_gsS,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    _gsS,_gsS,_gsS,_gsS,_gsS,_gsS,_gsS,_gsS,  // c-H c-I c-J c-K c-L c-M c-N c-O
    _gsS,_gsS,_gsS,_gsS,_gsS,_gsS,_gsS,_gsS,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    _gsS,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 80 81 82 83 84 85 86 87
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 88 89 8a 8b 8c 8d 8e 8f
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 90 91 92 93 94 95 96 97
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 98 99 9a 9b 9c 9d 9e 9f
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // a0 a1 a2 a3 a4 a5 a6 a7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // a8 a9 aa ab ac ad ae af
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // b0 b1 b2 b3 b4 b5 b6 b7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // b8 b9 ba bb bc bd be bf
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c0 c1 c2 c3 c4 c5 c6 c7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c8 c9 ca cb cc cd ce cf
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // d0 d1 d2 d3 d4 d5 d6 d7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // d8 d9 da db dc dd de df
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // e0 e1 e2 e3 e4 e5 e6 e7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // e8 e9 ea eb ec ed ee ef
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // f0 f1 f2 f3 f4 f5 f6 f7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // f8 f9 fa fb fc fd fe ff
// Latin-2      0x01
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 80 81 82 83 84 85 86 87
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 88 89 8a 8b 8c 8d 8e 8f
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 90 91 92 93 94 95 96 97
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 98 99 9a 9b 9c 9d 9e 9f
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // a0 a1 a2 a3 a4 a5 a6 a7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // a8 a9 aa ab ac ad ae af
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // b0 b1 b2 b3 b4 b5 b6 b7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // b8 b9 ba bb bc bd be bf
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c0 c1 c2 c3 c4 c5 c6 c7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c8 c9 ca cb cc cd ce cf
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // d0 d1 d2 d3 d4 d5 d6 d7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // d8 d9 da db dc dd de df
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // e0 e1 e2 e3 e4 e5 e6 e7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // e8 e9 ea eb ec ed ee ef
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // f0 f1 f2 f3 f4 f5 f6 f7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // f8 f9 fa fb fc fd fe ff
// Latin-3      0x02
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 80 81 82 83 84 85 86 87
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 88 89 8a 8b 8c 8d 8e 8f
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 90 91 92 93 94 95 96 97
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 98 99 9a 9b 9c 9d 9e 9f
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // a0 a1 a2 a3 a4 a5 a6 a7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // a8 a9 aa ab ac ad ae af
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // b0 b1 b2 b3 b4 b5 b6 b7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // b8 b9 ba bb bc bd be bf
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c0 c1 c2 c3 c4 c5 c6 c7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c8 c9 ca cb cc cd ce cf
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // d0 d1 d2 d3 d4 d5 d6 d7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // d8 d9 da db dc dd de df
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // e0 e1 e2 e3 e4 e5 e6 e7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // e8 e9 ea eb ec ed ee ef
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // f0 f1 f2 f3 f4 f5 f6 f7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // f8 f9 fa fb fc fd fe ff
// Latin-4      0x03
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 80 81 82 83 84 85 86 87
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 88 89 8a 8b 8c 8d 8e 8f
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 90 91 92 93 94 95 96 97
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 98 99 9a 9b 9c 9d 9e 9f
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // a0 a1 a2 a3 a4 a5 a6 a7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // a8 a9 aa ab ac ad ae af
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // b0 b1 b2 b3 b4 b5 b6 b7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // b8 b9 ba bb bc bd be bf
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c0 c1 c2 c3 c4 c5 c6 c7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c8 c9 ca cb cc cd ce cf
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // d0 d1 d2 d3 d4 d5 d6 d7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // d8 d9 da db dc dd de df
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // e0 e1 e2 e3 e4 e5 e6 e7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // e8 e9 ea eb ec ed ee ef
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // f0 f1 f2 f3 f4 f5 f6 f7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // f8 f9 fa fb fc fd fe ff
// Katakana     0x04
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 80 81 82 83 84 85 86 87
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 88 89 8a 8b 8c 8d 8e 8f
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 90 91 92 93 94 95 96 97
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 98 99 9a 9b 9c 9d 9e 9f
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // a0 a1 a2 a3 a4 a5 a6 a7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // a8 a9 aa ab ac ad ae af
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // b0 b1 b2 b3 b4 b5 b6 b7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // b8 b9 ba bb bc bd be bf
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c0 c1 c2 c3 c4 c5 c6 c7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c8 c9 ca cb cc cd ce cf
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // d0 d1 d2 d3 d4 d5 d6 d7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // d8 d9 da db dc dd de df
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // e0 e1 e2 e3 e4 e5 e6 e7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // e8 e9 ea eb ec ed ee ef
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // f0 f1 f2 f3 f4 f5 f6 f7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // f8 f9 fa fb fc fd fe ff
// Arabic       0x05
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 80 81 82 83 84 85 86 87
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 88 89 8a 8b 8c 8d 8e 8f
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 90 91 92 93 94 95 96 97
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 98 99 9a 9b 9c 9d 9e 9f
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // a0 a1 a2 a3 a4 a5 a6 a7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // a8 a9 aa ab ac ad ae af
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // b0 b1 b2 b3 b4 b5 b6 b7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // b8 b9 ba bb bc bd be bf
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c0 c1 c2 c3 c4 c5 c6 c7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c8 c9 ca cb cc cd ce cf
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // d0 d1 d2 d3 d4 d5 d6 d7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // d8 d9 da db dc dd de df
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // e0 e1 e2 e3 e4 e5 e6 e7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // e8 e9 ea eb ec ed ee ef
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // f0 f1 f2 f3 f4 f5 f6 f7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // f8 f9 fa fb fc fd fe ff
// Cyrillic     0x06
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 80 81 82 83 84 85 86 87
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 88 89 8a 8b 8c 8d 8e 8f
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 90 91 92 93 94 95 96 97
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 98 99 9a 9b 9c 9d 9e 9f
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // a0 a1 a2 a3 a4 a5 a6 a7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // a8 a9 aa ab ac ad ae af
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // b0 b1 b2 b3 b4 b5 b6 b7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // b8 b9 ba bb bc bd be bf
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c0 c1 c2 c3 c4 c5 c6 c7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c8 c9 ca cb cc cd ce cf
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // d0 d1 d2 d3 d4 d5 d6 d7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // d8 d9 da db dc dd de df
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // e0 e1 e2 e3 e4 e5 e6 e7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // e8 e9 ea eb ec ed ee ef
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // f0 f1 f2 f3 f4 f5 f6 f7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // f8 f9 fa fb fc fd fe ff
// Greek        0x07
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 80 81 82 83 84 85 86 87
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 88 89 8a 8b 8c 8d 8e 8f
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 90 91 92 93 94 95 96 97
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 98 99 9a 9b 9c 9d 9e 9f
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // a0 a1 a2 a3 a4 a5 a6 a7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // a8 a9 aa ab ac ad ae af
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // b0 b1 b2 b3 b4 b5 b6 b7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // b8 b9 ba bb bc bd be bf
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c0 c1 c2 c3 c4 c5 c6 c7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c8 c9 ca cb cc cd ce cf
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // d0 d1 d2 d3 d4 d5 d6 d7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // d8 d9 da db dc dd de df
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // e0 e1 e2 e3 e4 e5 e6 e7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // e8 e9 ea eb ec ed ee ef
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // f0 f1 f2 f3 f4 f5 f6 f7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // f8 f9 fa fb fc fd fe ff
// Technical    0x08
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 80 81 82 83 84 85 86 87
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 88 89 8a 8b 8c 8d 8e 8f
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 90 91 92 93 94 95 96 97
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 98 99 9a 9b 9c 9d 9e 9f
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // a0 a1 a2 a3 a4 a5 a6 a7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // a8 a9 aa ab ac ad ae af
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // b0 b1 b2 b3 b4 b5 b6 b7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // b8 b9 ba bb bc bd be bf
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c0 c1 c2 c3 c4 c5 c6 c7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c8 c9 ca cb cc cd ce cf
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // d0 d1 d2 d3 d4 d5 d6 d7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // d8 d9 da db dc dd de df
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // e0 e1 e2 e3 e4 e5 e6 e7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // e8 e9 ea eb ec ed ee ef
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // f0 f1 f2 f3 f4 f5 f6 f7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // f8 f9 fa fb fc fd fe ff
// Special      0x09
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 80 81 82 83 84 85 86 87
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 88 89 8a 8b 8c 8d 8e 8f
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 90 91 92 93 94 95 96 97
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 98 99 9a 9b 9c 9d 9e 9f
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // a0 a1 a2 a3 a4 a5 a6 a7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // a8 a9 aa ab ac ad ae af
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // b0 b1 b2 b3 b4 b5 b6 b7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // b8 b9 ba bb bc bd be bf
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c0 c1 c2 c3 c4 c5 c6 c7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c8 c9 ca cb cc cd ce cf
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // d0 d1 d2 d3 d4 d5 d6 d7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // d8 d9 da db dc dd de df
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // e0 e1 e2 e3 e4 e5 e6 e7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // e8 e9 ea eb ec ed ee ef
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // f0 f1 f2 f3 f4 f5 f6 f7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // f8 f9 fa fb fc fd fe ff
// Publishing   0x0A
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 80 81 82 83 84 85 86 87
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 88 89 8a 8b 8c 8d 8e 8f
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 90 91 92 93 94 95 96 97
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 98 99 9a 9b 9c 9d 9e 9f
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // a0 a1 a2 a3 a4 a5 a6 a7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // a8 a9 aa ab ac ad ae af
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // b0 b1 b2 b3 b4 b5 b6 b7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // b8 b9 ba bb bc bd be bf
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c0 c1 c2 c3 c4 c5 c6 c7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c8 c9 ca cb cc cd ce cf
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // d0 d1 d2 d3 d4 d5 d6 d7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // d8 d9 da db dc dd de df
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // e0 e1 e2 e3 e4 e5 e6 e7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // e8 e9 ea eb ec ed ee ef
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // f0 f1 f2 f3 f4 f5 f6 f7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // f8 f9 fa fb fc fd fe ff
// Apl          0x0B
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 80 81 82 83 84 85 86 87
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 88 89 8a 8b 8c 8d 8e 8f
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 90 91 92 93 94 95 96 97
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 98 99 9a 9b 9c 9d 9e 9f
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // a0 a1 a2 a3 a4 a5 a6 a7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // a8 a9 aa ab ac ad ae af
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // b0 b1 b2 b3 b4 b5 b6 b7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // b8 b9 ba bb bc bd be bf
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c0 c1 c2 c3 c4 c5 c6 c7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c8 c9 ca cb cc cd ce cf
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // d0 d1 d2 d3 d4 d5 d6 d7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // d8 d9 da db dc dd de df
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // e0 e1 e2 e3 e4 e5 e6 e7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // e8 e9 ea eb ec ed ee ef
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // f0 f1 f2 f3 f4 f5 f6 f7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // f8 f9 fa fb fc fd fe ff
// Hebrew       0x0C
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 80 81 82 83 84 85 86 87
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 88 89 8a 8b 8c 8d 8e 8f
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 90 91 92 93 94 95 96 97
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 98 99 9a 9b 9c 9d 9e 9f
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // a0 a1 a2 a3 a4 a5 a6 a7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // a8 a9 aa ab ac ad ae af
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // b0 b1 b2 b3 b4 b5 b6 b7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // b8 b9 ba bb bc bd be bf
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c0 c1 c2 c3 c4 c5 c6 c7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c8 c9 ca cb cc cd ce cf
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // d0 d1 d2 d3 d4 d5 d6 d7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // d8 d9 da db dc dd de df
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // e0 e1 e2 e3 e4 e5 e6 e7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // e8 e9 ea eb ec ed ee ef
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // f0 f1 f2 f3 f4 f5 f6 f7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // f8 f9 fa fb fc fd fe ff
// Ibm          0x0D
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 80 81 82 83 84 85 86 87
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 88 89 8a 8b 8c 8d 8e 8f
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 90 91 92 93 94 95 96 97
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 98 99 9a 9b 9c 9d 9e 9f
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // a0 a1 a2 a3 a4 a5 a6 a7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // a8 a9 aa ab ac ad ae af
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // b0 b1 b2 b3 b4 b5 b6 b7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // b8 b9 ba bb bc bd be bf
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c0 c1 c2 c3 c4 c5 c6 c7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c8 c9 ca cb cc cd ce cf
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // d0 d1 d2 d3 d4 d5 d6 d7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // d8 d9 da db dc dd de df
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // e0 e1 e2 e3 e4 e5 e6 e7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // e8 e9 ea eb ec ed ee ef
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // f0 f1 f2 f3 f4 f5 f6 f7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // f8 f9 fa fb fc fd fe ff
// Unused-1     0x0E
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 80 81 82 83 84 85 86 87
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 88 89 8a 8b 8c 8d 8e 8f
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 90 91 92 93 94 95 96 97
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 98 99 9a 9b 9c 9d 9e 9f
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // a0 a1 a2 a3 a4 a5 a6 a7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // a8 a9 aa ab ac ad ae af
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // b0 b1 b2 b3 b4 b5 b6 b7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // b8 b9 ba bb bc bd be bf
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c0 c1 c2 c3 c4 c5 c6 c7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c8 c9 ca cb cc cd ce cf
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // d0 d1 d2 d3 d4 d5 d6 d7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // d8 d9 da db dc dd de df
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // e0 e1 e2 e3 e4 e5 e6 e7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // e8 e9 ea eb ec ed ee ef
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // f0 f1 f2 f3 f4 f5 f6 f7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // f8 f9 fa fb fc fd fe ff
// Unused-2     0x0F
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 80 81 82 83 84 85 86 87
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 88 89 8a 8b 8c 8d 8e 8f
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 90 91 92 93 94 95 96 97
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 98 99 9a 9b 9c 9d 9e 9f
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // a0 a1 a2 a3 a4 a5 a6 a7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // a8 a9 aa ab ac ad ae af
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // b0 b1 b2 b3 b4 b5 b6 b7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // b8 b9 ba bb bc bd be bf
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c0 c1 c2 c3 c4 c5 c6 c7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // c8 c9 ca cb cc cd ce cf
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // d0 d1 d2 d3 d4 d5 d6 d7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // d8 d9 da db dc dd de df
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // e0 e1 e2 e3 e4 e5 e6 e7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // e8 e9 ea eb ec ed ee ef
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // f0 f1 f2 f3 f4 f5 f6 f7
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // f8 f9 fa fb fc fd fe ff
};


global  short  const   Gsm_Sym_Order   [GSM_MAX_SYMB] = {
// Latin-1      0x00
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2A,0x2B,0x2C,0x2D,0x2E,0x2F,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3A,0x3B,0x3C,0x3D,0x3E,0x3F,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5A,0x5B,0x5C,0x5D,0x5E,0x5F,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x58,0x59,0x5A,0x5B,0x5C,0x5D,0x5E,0x5F,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff

// Latin-2      0x01
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Latin-3      0x02
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Latin-4      0x03
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Katakana     0x04
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Arabic       0x05
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Cyrillic     0x06
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8A,0x8B,0x8C,0x8D,0x8E,0x8F,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F,  // 98 99 9a 9b 9c 9d 9e 9f
    0xA0,0xA1,0xA2,0xA3,0xA4,0xA5,0xA6,0xA7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF,  // a8 a9 aa ab ac ad ae af
    0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,  // b8 b9 ba bb bc bd be bf
    0xDE,0xC0,0xC1,0xD6,0xC4,0xC5,0xD4,0xC3,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xD5,0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,  // c8 c9 ca cb cc cd ce cf
    0xCF,0xDF,0xD0,0xD1,0xD2,0xD3,0xC6,0xC2,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xDC,0xDB,0xC7,0xD8,0xDD,0xD9,0xD7,0xDA,  // d8 d9 da db dc dd de df
    0xDE,0xC0,0xC1,0xD6,0xC4,0xC5,0xD4,0xC3,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xD5,0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,  // e8 e9 ea eb ec ed ee ef
    0xCF,0xDF,0xD0,0xD1,0xD2,0xD3,0xC6,0xC2,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xDC,0xDB,0xC7,0xD8,0xDD,0xD9,0xD7,0xDA,  // f8 f9 fa fb fc fd fe ff

// Greek        0x07
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Technical    0x08
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Special      0x09
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Publishing   0x0A
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Apl          0x0B
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Hebrew       0x0C
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Ibm          0x0D
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Unused-1     0x0E
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Unused-2     0x0F
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
};

global  tiny    const   Gsm_To_Lower    [GSM_MAX_SYMB] = {
// Latin-1      0x00
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x78,0x79,0x7a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Latin-2      0x01
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Latin-3      0x02
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Latin-4      0x03
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Katakana     0x04
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Arabic       0x05
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Cyrillic     0x06
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // c8 c9 ca cb cc cd ce cf
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Greek        0x07
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Technical    0x08
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Special      0x09
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Publishing   0x0A
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Apl          0x0B
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Hebrew       0x0C
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Ibm          0x0D
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Unused-1     0x0E
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Unused-2     0x0F
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
};

global  tiny    const   Gsm_To_Upper    [GSM_MAX_SYMB] = {
// Latin-1      0x00
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x58,0x59,0x5a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // f8 f9 fa fb fc fd fe ff
// Latin-2      0x01
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Latin-3      0x02
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Latin-4      0x03
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Katakana     0x04
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Arabic       0x05
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Cyrillic     0x06
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // e8 e9 ea eb ec ed ee ef
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // f8 f9 fa fb fc fd fe ff
// Greek        0x07
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Technical    0x08
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Special      0x09
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Publishing   0x0A
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Apl          0x0B
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Hebrew       0x0C
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Ibm          0x0D
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Unused-1     0x0E
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
// Unused-2     0x0F
    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  // c-@ c-A c-B c-C c-D c-E c-F c-G
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  // c-H c-I c-J c-K c-L c-M c-N c-O
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  // c-P c-Q c-R c-S c-T c-U c-V c-W
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  // c-X c-Y c-Z ESC F_S G-S R-S U-S
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  // ' ' '!' '"' '#' '$' '%' '&' '''
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  // '(' ')' '*' '+' ',' '-' '.' '/'
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  // '0' '1' '2' '3' '4' '5' '6' '7'
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  // '8' '9' ':' ';' '<' '=' '>' '?'
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  // '@' 'A' 'B' 'C' 'D' 'E' 'F' 'G'
    0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  // 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O'
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  // 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W'
    0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  // 'X' 'Y' 'Z' '[' '\' ']' '^' '_'
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  // '`' 'a' 'b' 'c' 'd' 'e' 'f' 'g'
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,  // 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' '
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  // 'p' 'q' 'r' 's' 't' 'u' 'v' 'w'
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,  // 'x' 'y' 'z' '{' '|' '}' '~' DEL

    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,  // 80 81 82 83 84 85 86 87
    0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,  // 88 89 8a 8b 8c 8d 8e 8f
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,  // 90 91 92 93 94 95 96 97
    0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,  // 98 99 9a 9b 9c 9d 9e 9f
    0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,  // a0 a1 a2 a3 a4 a5 a6 a7
    0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,  // a8 a9 aa ab ac ad ae af
    0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,  // b0 b1 b2 b3 b4 b5 b6 b7
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,  // b8 b9 ba bb bc bd be bf
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,  // c0 c1 c2 c3 c4 c5 c6 c7
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,  // c8 c9 ca cb cc cd ce cf
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,  // d0 d1 d2 d3 d4 d5 d6 d7
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,  // d8 d9 da db dc dd de df
    0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,  // e0 e1 e2 e3 e4 e5 e6 e7
    0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,  // e8 e9 ea eb ec ed ee ef
    0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,  // f0 f1 f2 f3 f4 f5 f6 f7
    0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,  // f8 f9 fa fb fc fd fe ff
};

global  char    const*  const   Gsm_Cset_Names  [GSM_MAX_CSET] = {
    "Latin-1",  "Latin-2",  "Latin-3",  "Latin-4",  // 0x00, 0x01, 0x02, 0x03
    "Katakana", "Arabic",   "Cyrillic", "Greek",    // 0x04, 0x05, 0x06, 0x07
    "Technical","Special",  "Publishing","Apl",     // 0x08, 0x09, 0x0A, 0x0B
    "Hebrew",   "Ibm",      "Unused-1",  "Unused-2" // 0x0C, 0x0D, 0x0E, 0X0F
};

local Ctk_Boolean* Is_Lower_Char ( int4 c )
  { return is_lower ( Gft_Xchar(c) ) ? CTK_TRUE : CTK_FALSE; }
local Ctk_Boolean* Is_Upper_Char ( int4 c )
  { return is_upper ( Gft_Xchar(c) ) ? CTK_TRUE : CTK_FALSE; }
local Ctk_Boolean* Is_Alpha_Char ( int4 c )
  { return is_alpha ( Gft_Xchar(c) ) ? CTK_TRUE : CTK_FALSE; }
local Ctk_Boolean* Is_Digit_Char ( int4 c )
  { return is_digit ( Gft_Xchar(c) ) ? CTK_TRUE : CTK_FALSE; }
local Ctk_Boolean* Is_Xdigit_Char( int4 c )
  { return is_xdigit( Gft_Xchar(c) ) ? CTK_TRUE : CTK_FALSE; }
local Ctk_Boolean* Is_Alnum_Char ( int4 c )
  { return is_alnum ( Gft_Xchar(c) ) ? CTK_TRUE : CTK_FALSE; }
local Ctk_Boolean* Is_Space_Char ( int4 c )
  { return is_space ( Gft_Xchar(c) ) ? CTK_TRUE : CTK_FALSE; }
local Ctk_Boolean* Is_Punct_Char ( int4 c )
  { return is_punct ( Gft_Xchar(c) ) ? CTK_TRUE : CTK_FALSE; }
local Ctk_Boolean* Is_Print_Char ( int4 c )
  { return is_print ( Gft_Xchar(c) ) ? CTK_TRUE : CTK_FALSE; }
local Ctk_Boolean* Is_Graph_Char ( int4 c )
  { return is_graph ( Gft_Xchar(c) ) ? CTK_TRUE : CTK_FALSE; }
local Ctk_Boolean* Is_Cntrl_Char ( int4 c )
  { return is_cntrl ( Gft_Xchar(c) ) ? CTK_TRUE : CTK_FALSE; }
local Ctk_Boolean* Is_Ascii_Char ( int4 c )
  { return is_ascii ( Gft_Xchar(c) ) ? CTK_TRUE : CTK_FALSE; }

local int4 To_Lower_Char ( int4 c ) { return char(to_lower(Gft_Xchar(c))); }
local int4 To_Upper_Char ( int4 c ) { return char(to_upper(Gft_Xchar(c))); }

local Ctk_Boolean* Is_Lower_Symb ( int4 c )
  { return is_lower (c) ? CTK_TRUE : CTK_FALSE; }
local Ctk_Boolean* Is_Upper_Symb ( int4 c )
  { return is_upper (c) ? CTK_TRUE : CTK_FALSE; }
local Ctk_Boolean* Is_Alpha_Symb ( int4 c )
  { return is_alpha (c) ? CTK_TRUE : CTK_FALSE; }
local Ctk_Boolean* Is_Digit_Symb ( int4 c )
  { return is_digit (c) ? CTK_TRUE : CTK_FALSE; }
local Ctk_Boolean* Is_Xdigit_Symb( int4 c )
  { return is_xdigit(c) ? CTK_TRUE : CTK_FALSE; }
local Ctk_Boolean* Is_Alnum_Symb ( int4 c )
  { return is_alnum (c) ? CTK_TRUE : CTK_FALSE; }
local Ctk_Boolean* Is_Space_Symb ( int4 c )
  { return is_space (c) ? CTK_TRUE : CTK_FALSE; }
local Ctk_Boolean* Is_Punct_Symb ( int4 c )
  { return is_punct (c) ? CTK_TRUE : CTK_FALSE; }
local Ctk_Boolean* Is_Print_Symb ( int4 c )
  { return is_print (c) ? CTK_TRUE : CTK_FALSE; }
local Ctk_Boolean* Is_Graph_Symb ( int4 c )
  { return is_graph (c) ? CTK_TRUE : CTK_FALSE; }
local Ctk_Boolean* Is_Cntrl_Symb ( int4 c )
  { return is_cntrl (c) ? CTK_TRUE : CTK_FALSE; }
local Ctk_Boolean* Is_Ascii_Symb ( int4 c )
  { return is_ascii (c) ? CTK_TRUE : CTK_FALSE; }

local int4 To_Lower_Symb ( int4 c ) { return to_lower (c); }
local int4 To_Upper_Symb ( int4 c ) { return to_upper (c); }

local Ctk_Primitive
p1("Is_Lower_Char", cnv(&Is_Lower_Char), "char" ),
p2("Is_Upper_Char", cnv(&Is_Upper_Char), "char" ),
p3("Is_Alpha_Char", cnv(&Is_Alpha_Char), "char" ),
p4("Is_Digit_Char", cnv(&Is_Digit_Char), "char" ),
p5("Is_Xdigit_Char", cnv(&Is_Xdigit_Char), "char" ),
p6("Is_Alnum_Char", cnv(&Is_Alnum_Char), "char" ),
p7("Is_Space_Char", cnv(&Is_Space_Char), "char" ),
p8("Is_Punct_Char", cnv(&Is_Punct_Char), "char" ),
p9("Is_Print_Char", cnv(&Is_Print_Char), "char" ),
p10("Is_Graph_Char", cnv(&Is_Graph_Char), "char" ),
p11("Is_Cntrl_Char", cnv(&Is_Cntrl_Char), "char" ),
p12("Is_Ascii_Char", cnv(&Is_Ascii_Char), "char" ),
p13("To_Lower_Char", cnv(&To_Lower_Char), "char" ),
p14("To_Upper_Char", cnv(&To_Upper_Char), "char" ),

p20("Is_Lower_Symb", cnv(&Is_Lower_Symb), "wchar" ),
p21("Is_Upper_Symb", cnv(&Is_Upper_Symb), "wchar" ),
p22("Is_Alpha_Symb", cnv(&Is_Alpha_Symb), "wchar" ),
p23("Is_Digit_Symb", cnv(&Is_Digit_Symb), "wchar" ),
p24("Is_Xdigit_Symb",cnv(&Is_Xdigit_Symb),"wchar" ),
p25("Is_Alnum_Symb", cnv(&Is_Alnum_Symb), "wchar" ),
p26("Is_Space_Symb", cnv(&Is_Space_Symb), "wchar" ),
p27("Is_Punct_Symb", cnv(&Is_Punct_Symb), "wchar" ),
p28("Is_Print_Symb", cnv(&Is_Print_Symb), "wchar" ),
p29("Is_Graph_Symb", cnv(&Is_Graph_Symb), "wchar" ),
p30("Is_Cntrl_Symb", cnv(&Is_Cntrl_Symb), "wchar" ),
p31("Is_Ascii_Symb", cnv(&Is_Ascii_Symb), "wchar" ),
p32("To_Lower_Symb", cnv(&To_Lower_Symb), "wchar" ),
p33("To_Upper_Symb", cnv(&To_Upper_Symb), "wchar" );

